import * as basket from "../eaiws/basket";
import { BasketItem } from "./BasketItem";
import { type EditableLabelItem, ItemUpdateFlags } from "./BaseItem";
import { type Basket } from "./Basket";
export declare class FolderItem extends BasketItem implements EditableLabelItem {
    get isGroup(): boolean;
    constructor(pManager: Basket, pParent: BasketItem | null, pChildIndex: number, pEaiwsItem: basket.BasketItem);
    /** Returns the long text for this folder */
    getLongText(): Promise<Array<basket.DisplayText>>;
    /**
     * Sets the label (name) of this folder.
     */
    setLabel(pLabel: string): Promise<void>;
    /**
     * Sets the long text of this folder.
     */
    setLongText(pText: string): Promise<void>;
    /**
     * Sets the `showSubTotal` flag of this folder.
     */
    setShowSubTotal(pShow: boolean): Promise<void>;
    protected performUpdates(pFlags: ItemUpdateFlags): Promise<void>;
    private mLongText;
    private mLongTextLock;
}
