import * as basket from "../eaiws/basket";
import { BasketItem } from "./BasketItem";
import { type EditableLabelItem, ItemUpdateFlags } from "./BaseItem";
import { type Basket } from "./Basket";
export declare class TextItem extends BasketItem implements EditableLabelItem {
    constructor(pManager: Basket, pParent: BasketItem | null, pChildIndex: number, pEaiwsItem: basket.BasketItem);
    /** Returns the long text for this folder */
    getLongText(): Promise<Array<basket.DisplayText>>;
    /**
     * Sets the label (short text) of this text item.
     */
    setLabel(pLabel: string): Promise<void>;
    /**
     * Sets the long text of this text item.
     */
    setLongText(pText: string): Promise<void>;
    protected performUpdates(pFlags: ItemUpdateFlags): Promise<void>;
    private mLongText;
    private mLongTextLock;
}
