import type * as basket from "../eaiws/basket";
import { BaseItemManager } from "./BaseItemManager";
import { ViewItem } from "./ViewItem";
import type { Basket } from "./Basket";
export declare class View extends BaseItemManager<ViewItem, View> {
    get viewId(): string;
    get viewConfig(): basket.BasketViewConfig;
    get basket(): Basket;
    get generatedImageResolution(): number;
    get includeCalculationErrorsInInconsistencies(): boolean;
    /**
     * Can be used to define extra pricing information which sould be part of the
     * `ArticleProperties.priceInfo`. See EAIWS documentation for further information.
     */
    get extraPriceInfoSelectors(): Array<string> | undefined;
    set extraPriceInfoSelectors(pSelectors: Array<string> | undefined);
    update(pForce?: boolean): Promise<void>;
    /** Returns the view item for the given basket item id */
    getItemByBasketId(pBasketItemId: string): ViewItem | null;
    protected createItem(pParent: ViewItem | null, pChildIndex: number, pEaiwsItem: basket.BasketItem): ViewItem;
    private mBasket;
    private mViewConfig;
    private mBasketItemIdMap;
    private mIsUpToDate;
    private constructor();
    private initialize;
}
