import { BaseItem } from "./BaseItem";
import type { ViewSetArticleItem } from "./ViewSetArticleItem";
import type { View } from "./View";
import type { BasketItem } from "./BasketItem";
export declare class ViewItem extends BaseItem<ViewItem, View> {
    get view(): View;
    /**
     * Returns the first BasketItem referenced by this ViewItem.
     * Use getBasketItems() to get all items.
     */
    getFirstBasketItem(): BasketItem | null;
    getBasketItems(): Array<BasketItem>;
    /**
     * Searches for the set article item.
     */
    findSetArticle(): ViewSetArticleItem | null;
    protected get asType(): ViewItem;
    protected registerItem(): void;
}
