import { ERR_FAILED, newError } from "../../utils/error";
import { deleteItems as deleteBasketItems, cloneItem as cloneBasketItem } from "./Actions";
export async function deleteViewItems(pView, pItems, pOptions) {
    const tBasketItems = new Array();
    for (const tItem of pItems) {
        tBasketItems.push(...(tItem).getBasketItems());
    }
    await deleteBasketItems(pView.basket, tBasketItems, pOptions);
    return (pView.update());
}
export async function cloneViewItem(pView, pItem) {
    const tBasketItems = pItem.getBasketItems();
    if (tBasketItems.length === 0)
        throw newError(ERR_FAILED, "No basket item found.");
    if (tBasketItems.length > 1 && pView.viewConfig.mergeMode !== "Compact")
        throw newError(ERR_FAILED, "Not supported for merged items.");
    const tNewBasketItem = await cloneBasketItem(pView.basket, tBasketItems[0]);
    await pView.update();
    const tNewItem = pView.getItemByBasketId(tNewBasketItem.id);
    if (tNewItem == null)
        throw newError(ERR_FAILED, "View item not found.");
    return (tNewItem);
}
