import type { Property, PropertyValueType } from "../core/prop/Property";
import { PropertyClass } from "../core/prop/Property";
import type { PropertyChangedResult, PropertyProvider } from "../core/prop/PropertyProvider";
import type { EaiwsSession } from "../eaiws";
import * as basket from "../eaiws/basket";
export interface ArticlePropertyUserData {
    eaiwsProperty: basket.Property;
    eaiwsArticleData: basket.ArticleData;
}
export declare abstract class ArticlePropertyHelpers {
    static GetProperties(pItemId: string, pSession: EaiwsSession, pProvider: PropertyProvider, pArticleData: basket.ArticleData, pSetValueCallback: (pEaiProperty: basket.Property, pValue: PropertyValueType) => Promise<PropertyChangedResult>): Array<Property> | null;
    static GetPropertyClasses(pArticleData: basket.ArticleData): Array<PropertyClass> | null;
    static GetPropertyUserData(pProperty: Property): ArticlePropertyUserData | null;
    private static GetClassKey;
    private static CreateProperty;
    private static CreatePropertyValue;
    private static GetPropertyChoices;
}
