import type { SceneElement } from "../core/mdl/SceneElement";
import type { ArticleManager } from "./ArticleManager";
export interface BoundingBoxDimensionsOptions {
    /**
     * Color of the dimensions as hex string.
     * @defaultValue "#595959"
     */
    color: string;
    /**
     * Custom scale factor of the dimension.
     * @defaultValue 1
     */
    scaleFactor: number;
    /**
     * Custom offset factor of the dimension which is used increase/decrease the offset of the dimension to the element.
     * @defaultValue 1
     */
    offsetFactor: number;
}
export declare class BoundingBoxDimensions {
    constructor(pElements: ReadonlyArray<SceneElement>, pManager: ArticleManager, pOptions?: Partial<BoundingBoxDimensionsOptions>);
    dispose(): void;
    private mMngr;
    private mElements;
    private mOptions;
    private mBoxPoints;
    private mBoxCenter;
    private mDimensionX;
    private mDimensionY;
    private mDimensionZ;
    private onResetBounds;
    private onBeforeCameraRender;
    private prepareDimension;
    private disposeDimension;
    private updateDimensions;
    private updateBoundingBox;
    private updateDimensionLength;
    private buildBoxEdge;
    private buildBoxSide;
    private getCameraDirectionToPoint;
    private updateDimension;
    private updateDimensionLines;
    private updateDimensionText;
}
