import { TransformNode } from "@babylonjs/core/Meshes/transformNode";
import type { ArticleManager } from "./ArticleManager";
import type { MainArticleElement } from "./MainArticleElement";
export interface PlaceholderCreator {
    create(pArticle: MainArticleElement, pSubArticleIds: Array<string>): Promise<TransformNode>;
}
/**
 * Creates an empty TransformNode for the given article.
 */
export declare class DummyPlaceholderCreator implements PlaceholderCreator {
    constructor(pArticleManager: ArticleManager);
    create(pArticle: MainArticleElement, pSubArticleIds: Array<string>): Promise<TransformNode>;
    private mApp;
}
export declare class DefaultPlaceholderCreator implements PlaceholderCreator {
    constructor(pArticleManager: ArticleManager);
    create(pArticle: MainArticleElement, pSubArticleIds: Array<string>): Promise<TransformNode>;
    private mApp;
    private mLoadImageLock;
    private mFrameImg;
    private mDefaultCatalogImg;
    private createTexture;
    private createMesh;
    private loadFrameImg;
    private loadDefaultCatalogImg;
    private loadImgFromUrl;
    private getTextLines;
    private limitLines;
}
