import { Vector3 } from "@babylonjs/core/Maths/math.vector";
import "@babylonjs/core/Rendering/boundingBoxRenderer";
import type { Application } from "../../core/Application";
import { AbstractTool } from "../../core/tool/";
import type { InputState } from "../../core/view";
import * as basket from "../../eaiws/basket";
import { DimChangeMode } from "./DimChangeMode";
export declare class DimChangeTool extends AbstractTool {
    constructor(pApp: Application, pDimChangeModeContext: DimChangeMode.Context, pBBOrigin: Vector3, pRefPoint: Vector3, pDimChange1: basket.OAPDimChange, pDimChange2: basket.OAPDimChange | undefined, pPlane: DimChangeMode.Plane | undefined);
    start(pParameter: unknown): boolean;
    stop(): void;
    handlePointerUp(pEvent: PointerEvent, pState: InputState): void;
    handlePointerMove(pEvent: PointerEvent, pState: InputState): void;
    private mView;
    private mRefPlane;
    private mBBOrigin;
    private mDimChange1;
    private mDimChange2;
    private mDimChangeModeContext;
    private mArticle;
    private mPickPlane;
    private mRefPoint;
    private mLocalStartPoint;
    private mScaleDirection;
    private mArticleBounds;
    private mAxis;
    private mSnapGrip;
    private mFeedbackNode;
    private mFeedbackBox;
    private mFeedbackMat;
    private mLengthFeedback;
    private onCameraChanged;
    private prepareDimChange;
    private prepareAxisData;
    private preparePickPlane;
    private detectNegativeScale;
    private prepareSnapping;
    private createFeedback;
    private getPlanePickPos;
    private performSnap;
    private getVectorAxis;
    private setVectorAxis;
    private snapToChoiceValues;
    private finishDimChange;
    private applyScale;
    private adjustArticlePosition;
    private restartDimChangeMode;
}
