import { Vector3 } from "@babylonjs/core/Maths/math.vector";
import { Interactor as CoreInteractor } from "./../../core/tool/Interactor";
import * as basket from "./../../eaiws/basket";
import type { Interactors } from "./Interactors";
export declare class Interactor extends CoreInteractor {
    get oapInteractor(): basket.OAPInteractor;
    get interactors(): Interactors;
    get cachedBoundingClientRect(): ClientRect | undefined;
    get worldPosition(): Vector3;
    get hiddenMode(): boolean;
    constructor(pInteractors: Interactors, pOapInteractor: basket.OAPInteractor, pOapSymbol?: basket.OAPSymbolDisplay);
    /**
     * used from `Interactors.checkInteractorVisibility()`
     */
    setHidden(pHidden: boolean): void;
    private static readonly INTERACTOR_NAME_MAP;
    private static readonly INTERACTOR_NO_SMALL;
    private mInteractors;
    private mOapInteractor;
    private mWorldPosition;
    private mViewAngle?;
    private mWorldDirection?;
    private mHiddenMode;
    private mClientRect;
    private mUpdateVisibility;
    private mCurrentAngleVisibility;
    private mDimChangeAction;
    private onUpdateViewPosition;
    private getInteractorCssClass;
}
