import { GroupedMap, ListenableEvent } from "../utils";
import type { Application } from "./Application";
export declare class AppDocument {
    /**
     * Can be used to store application specific data inside the document.
     */
    get appData(): GroupedMap;
    get app(): Application;
    readonly eventBeforeClear: ListenableEvent<void, AppDocument>;
    readonly eventAfterClear: ListenableEvent<void, AppDocument>;
    readonly eventBeforeLoad: ListenableEvent<void, AppDocument>;
    /** Triggered after the document was loaded. If the event parameter is true, the loading was aborted or failed. */
    readonly eventAfterLoad: ListenableEvent<boolean, AppDocument>;
    readonly eventBeforeSave: ListenableEvent<void, AppDocument>;
    /** Triggered after the document was saved. If the event parameter is true, the saving was aborted or failed. */
    readonly eventAfterSave: ListenableEvent<boolean, AppDocument>;
    constructor(pApp: Application);
    clear(): void;
    private mApp;
    private mAppData;
}
