export class AppModule {
    /**
     * Will be called from the document everytime it gets cleared.
     * Modules should clear its document related data.
     */
    clearDocumentData() { }
    /**
     * Will be called from the document everytime after it gets loaded.
     * If the promise is rejected with a core.io.AbortError the whole document load process will be aborted.
     */
    loadDocumentData(pContext, pData) {
        return (Promise.resolve());
    }
    /**
     * Will be called from the document everytime it gets saved.
     * If the promise is rejected with a core.io.AbortError the whole document save process will be aborted.
     */
    saveDocumentData(pContext, pOptions) {
        return (Promise.resolve(null));
    }
}
