import { Vector3 } from "@babylonjs/core/Maths/math.vector";
import { ListenableEvent } from "../utils";
export interface AppSnappingSettings {
    /** if false grid snapping is disabled (default: true) */
    gridEnabled: boolean;
    /** if true the grid size will determined dynamically, the gridSize setting will be ignored (default: true) */
    gridDynamic: boolean;
    /** size of the snapping grid for each axis (default: [0.1, 0.1, 0.1]) */
    gridSize: Vector3;
    /** if false bounding box snapping is disabled (default: true) */
    boundingBoxEnabled: boolean;
}
export declare class AppSettings {
    /** Settings for the snapping. Used from tools with snapping support. */
    get snapping(): AppSnappingSettings;
    readonly eventSnappingChanged: ListenableEvent<void, AppSettings>;
    constructor();
    /** Set new snapping settings. Undefined settings will not be changed. */
    setSnapping(pSettings: Partial<AppSnappingSettings>): void;
    private mSnapping;
}
