import type { Application } from "../Application";
import type { Command } from "./Command";
export declare abstract class AbstractCommand implements Command {
    constructor(pApp: Application);
    isAvailable(): boolean;
    isUndoable(): boolean;
    isSignificant(): boolean;
    abstract execute(pParameter: unknown): Promise<boolean>;
    undo(): Promise<void>;
    redo(): Promise<void>;
    dispose(): void;
    protected mApp: Application;
}
