import { ListenableEvent } from "../../utils";
import type { Command } from "./Command";
export declare class CommandManager {
    get canUndo(): boolean;
    get canRedo(): boolean;
    get recordingEnabled(): boolean;
    set recordingEnabled(pEnabled: boolean);
    get historySize(): number;
    /**
     * Will be triggered if the undo/redo history has changed.
     */
    readonly eventHistoryChanged: ListenableEvent<void, CommandManager>;
    constructor();
    executeCommand(pCommand: Command, pCommandParameter?: unknown): Promise<boolean>;
    beginUndoSection(): void;
    endUndoSection(): void;
    undo(): Promise<void>;
    redo(): Promise<void>;
    clearHistory(): void;
    setHistorySize(pSize: number): void;
    private mCurrentSection;
    private mSectionDepth;
    private mRecordingEnabled;
    private mHistorySize;
    private mUndoSections;
    private mRedoSections;
    private addCommandToHistory;
    private internal_clearHistory;
    private ensureHistorySize;
}
