import type { Node } from "@babylonjs/core/node";
import type { Application } from "../Application";
import type { SceneElement } from "../mdl/SceneElement";
import { AbstractCommand } from "./AbstractCommand";
export declare abstract class AbstractInsertDeleteElements extends AbstractCommand {
    constructor(pApp: Application, pElements: ReadonlyArray<SceneElement>);
    isAvailable(): boolean;
    isUndoable(): boolean;
    dispose(): void;
    protected mElements: Array<SceneElement>;
    protected mElementParents: Array<SceneElement | null>;
    protected mElementUndoData: Array<object | null>;
    protected mNodeParents: Array<Node | null>;
    protected mElementsDeleted: boolean;
    protected deleteElements(): void;
    protected insertElements(pAddToScene: boolean): void;
}
export declare class DeleteElements extends AbstractInsertDeleteElements {
    constructor(pApp: Application, pElements: ReadonlyArray<SceneElement>);
    execute(pParameter: unknown): Promise<boolean>;
    undo(): Promise<void>;
    redo(): Promise<void>;
}
export declare class InsertElements extends AbstractInsertDeleteElements {
    constructor(pApp: Application, pElements: ReadonlyArray<SceneElement>);
    execute(pParameter: unknown): Promise<boolean>;
    undo(): Promise<void>;
    redo(): Promise<void>;
}
