import { Vector3, Quaternion } from "@babylonjs/core/Maths/math.vector";
import type { Application } from "../Application";
import type { SceneElement } from "../mdl/SceneElement";
import { AbstractCommand } from "./AbstractCommand";
export declare class TransformElements extends AbstractCommand {
    constructor(pApp: Application, pElements: ReadonlyArray<SceneElement>);
    isAvailable(): boolean;
    isUndoable(): boolean;
    execute(pParameter: unknown): Promise<boolean>;
    undo(): Promise<void>;
    redo(): Promise<void>;
    /**
     * pTranslation is given in world coordinates.
     */
    translate(pTranslation: Vector3): void;
    /**
     * pRotation and pRefPoint are given in world coordinates if pLocal = false, otherwise in
     * local coordinates.
     */
    rotate(pRotation: Quaternion, pLocal: boolean, pRefPoint?: Vector3 | null): void;
    undoTransforms(): void;
    private mElements;
    private mInvWorldMatrix;
    private mInvWorldRotation;
    private mUndoTransforms;
    private mUndoData;
    private mRedoTransforms;
    private mRedoData;
}
