import { CustomError } from "../../utils/error";
//1.0 - initial version
//2.0 - switched to glTF 2.0 for geometries
//2.1 - fixed roughness of materials by switching env map
export const DOCUMENT_MAJOR_VERSION = 2;
export const DOCUMENT_MINOR_VERSION = 1;
export class FileNotFoundError extends CustomError {
    constructor(pFilename) {
        super(pFilename);
        Object.setPrototypeOf(this, FileNotFoundError.prototype);
        this.name = "FileNotFoundError";
    }
}
export class AbortError extends CustomError {
    constructor(pReason) {
        super(pReason);
        Object.setPrototypeOf(this, AbortError.prototype);
        this.name = "AbortError";
    }
}
