import type { ProgressCallback } from "../../utils";
import type { DocumentContainer } from "./Types";
export declare class ZipDocumentContainer implements DocumentContainer {
    static NewContainer(): ZipDocumentContainer;
    static LoadContainer(pData: ArrayBuffer | Blob): Promise<ZipDocumentContainer>;
    /** Level of compression, 0 means no compression. (range: [0, 9]) */
    compressionLevel: number;
    addFile(pData: ArrayBuffer | Blob | string, pFilename: string, pCompress?: boolean, pCacheable?: boolean): Promise<void>;
    addFileFromUrl(pUrl: string, pFilename: string, pBinary: boolean, pCompress?: boolean, pCacheable?: boolean): Promise<void>;
    addFileFromCache(pFilename: string, pCompress?: boolean): Promise<boolean>;
    getFile(pFilename: string, pBinary: false): Promise<string>;
    getFile(pFilename: string, pBinary: true): Promise<ArrayBuffer>;
    listFiles(pFolderPath?: string): Promise<Array<string>>;
    generateZip(pProgressCallback?: ProgressCallback): Promise<ArrayBuffer>;
    private mZip;
    private constructor();
}
