import type { AbstractMesh } from "@babylonjs/core/Meshes/abstractMesh";
import type { Geometry } from "@babylonjs/core/Meshes/geometry";
import { Mesh } from "@babylonjs/core/Meshes/mesh";
import type { Scene } from "@babylonjs/core/scene";
import type { ModelManager } from "./ModelManager";
export declare class GeometryManager {
    missingGeometries: Set<string>;
    get scene(): Scene;
    constructor(pModelManager: ModelManager);
    clear(): void;
    addGeometryMesh(pId: string, pGeometryMesh: Mesh): boolean;
    getGeometryMesh(pGeomId: string): Mesh | null;
    getGeometry(pId: string): Geometry | null;
    hasGeometry(pId: string): boolean;
    isFallbackGeometry(pGeometry: Geometry): boolean;
    getMeshGeometryId(pMesh: AbstractMesh): string | null;
    private static readonly CACHE_CLEANUP_INTERVAL;
    private mScene;
    private mMeshCache;
    private mLastCacheCleanUp;
    private onDisposeMesh;
    private cleanUpMeshCache;
}
