import { AbstractMesh } from "@babylonjs/core/Meshes/abstractMesh";
import type { TransformNode } from "@babylonjs/core/Meshes/transformNode";
import type { Application } from "../Application";
export declare class LayerManager {
    constructor(pApp: Application);
    clear(): void;
    isLayerVisible(pLayer: string): boolean;
    setLayerVisible(pLayer: string, pVisible: boolean): void;
    getMeshLayer(pMesh: AbstractMesh): string | null;
    setMeshLayer(pMesh: AbstractMesh, pLayer: string): void;
    /**
     * Returns a list of meshes which belong to the given layer.
     * If a parent node is given only the parent node and its children will be considered,
     * otherwise all SceneElements currently added to the ModelManager will be iterated.
     */
    getMeshesOnLayer(pLayer: string, pParent?: TransformNode): Array<AbstractMesh>;
    private static readonly NODEDATA_LAYER;
    private mApp;
    private mLayers;
    private applyLayerVisibility;
    private collectMeshesOnLayer;
}
