import { PBRMaterial as BJSPBRMaterial } from "@babylonjs/core/Materials/PBR/pbrMaterial";
import type { BaseTexture } from "@babylonjs/core/Materials/Textures/baseTexture";
import { Color3 } from "@babylonjs/core/Maths/math.color";
import type { MaterialManager } from "./MaterialManager";
import { Texture } from "./Texture";
export type OmatsType = "common" | "glass" | "glass_translucent" | "metal" | "metal_polished" | "illuminant";
export interface ConvertToPbrResult {
    metallic: number;
    roughness: number;
    albedo: Color3;
}
export declare class PbrMaterial extends BJSPBRMaterial {
    static DisableLighting: boolean;
    constructor(pName: string, pMatManager: MaterialManager);
    dispose(pForceDisposeEffect?: boolean, pForceDisposeTextures?: boolean): void;
    clone(pName: string): PbrMaterial;
    hasFallbackTextures(): boolean;
    replaceTexture(pCurrent: Texture, pNew: Texture): void;
    collectTextures(pCallback: (pTexture: BaseTexture | null) => void): void;
    static ConvertToPbrParameters(pDiffuseColor: Color3, pHasDiffuseTexture: boolean, pSpecularColor: Color3, pShininess: number, pReflectivity: number, pAlpha: number, pOmatsType?: OmatsType): ConvertToPbrResult;
    /** Enables alpha testing transparency mode for the given material. */
    static EnableAlphaTesting(pMat: PbrMaterial): void;
    private static readonly MAX_CONVERTED_ROUGHNESS;
    private mMatManger;
    private static ConvertToMetallic;
    private static ConvertToRoughness;
    private static ComputeLuminance;
    private static ComputeChroma;
    private static AdoptLuminance;
}
