import type { Mesh } from "@babylonjs/core/Meshes/mesh";
import type { Scene } from "@babylonjs/core/scene";
export declare abstract class GltfMesh {
    static GLTF_MIME_TYPE: string;
    static GLTF_EXTENSION: string;
    static BINARY_GLTF_MIME_TYPE: string;
    static BINARY_GLTF_EXTENSION: string;
    /**
     * Imports a gltf file (.gltf or .glb) from an url.
     */
    static ImportFromUrl(pUrl: string, pScene: Scene): Promise<Array<Mesh> | null>;
    /**
     * Imports a binary gltf (.glb) given as an ArrayBuffer.
     */
    static Import(pBuffer: ArrayBuffer, pScene: Scene): Array<Mesh> | null;
    /**
     * Exports the given mesh as a binary gltf (.glb)
     */
    static Export(pMesh: Mesh): ArrayBuffer | null;
}
