import type { Property } from "./Property";
import { PropertyClass } from "./Property";
/**  */
export interface PropertyGroup {
    class: PropertyClass;
    poperties: Array<Property>;
}
/** Options for `getGroupedProperties()` */
export interface GetPropertyGroupOptions {
    /** Name of the default class which will be used for properties without a class. */
    defaultClassName: string;
    /** If true property classes with identical names will be merged. (default: true) */
    mergeClassesWithIdenticalName?: boolean;
}
/**
 * Groups the provided properties according to their class and merges classes with identical names.
 * Empty groups will be removed.
 */
export declare function groupProperties(pProperties: Array<Property> | null, pPropertyClasses: Array<PropertyClass> | null, pOptions: GetPropertyGroupOptions): Array<PropertyGroup>;
