import type { AbstractMesh } from "@babylonjs/core/Meshes/abstractMesh";
import type { Mesh } from "@babylonjs/core/Meshes/mesh";
import type { Scene } from "@babylonjs/core/scene";
export interface ShadowGenerator {
    readonly enabled: boolean;
    dispose(): void;
    setEnabled(pEnabled: boolean): void;
    notifyModelInteraction(): void;
    prepareRenderFrame(pMultiSamplingStep: number, pMaxSteps: number): void;
    finalizeRenderFrame(pMultiSamplingStep: number, pMaxSteps: number): void;
}
export declare namespace ShadowGenerator {
    function disableMeshShadow(pMesh: AbstractMesh, pDisable?: boolean): void;
    function isMeshShadowDisabled(pMesh: AbstractMesh): boolean;
}
export interface ShadowOnlyFloorOptions {
    /** Size of the floor. (defaut: 20) */
    size: number;
    /** Intensity/darkness of the shadows. (defaut: 0.1) */
    shadowAlpha: number;
}
/**
 * Creates a floor which only shows shadows. Should be used in combination with shadow mapping.
 */
export declare function createShadowOnlyFloor(pScene: Scene, pOptions?: Partial<ShadowOnlyFloorOptions>): Mesh;
