import { ListenableEvent } from "../../utils";
import type { Application } from "../Application";
import type { InputState } from "../view/InputState";
import type { Tool } from "./Tool";
import { InteractionMode } from "./Tool";
export declare abstract class AbstractTool implements Tool {
    readonly eventStarted: ListenableEvent<void, Tool>;
    readonly eventStopped: ListenableEvent<void, Tool>;
    constructor(pApp: Application);
    isAvailable(): boolean;
    isRunning(): boolean;
    getInteractionMode(): InteractionMode;
    start(pParameter: unknown): boolean;
    stop(): void;
    handlePointerDown(pEvent: PointerEvent, pState: InputState): void;
    handlePointerUp(pEvent: PointerEvent, pState: InputState): void;
    handlePointerDblClick(pEvent: PointerEvent, pState: InputState): void;
    handlePointerMove(pEvent: PointerEvent, pState: InputState): void;
    handlePointerCancel(pEvent: PointerEvent, pState: InputState): void;
    handleKeyUp(pEvent: KeyboardEvent, pState: InputState): void;
    protected mApp: Application;
    protected setInteractionMode(pMode: InteractionMode): void;
    private mIsRunning;
    private mInteractionMode;
}
