import type { Quaternion } from "@babylonjs/core/Maths/math.vector";
import { Matrix, Vector3 } from "@babylonjs/core/Maths/math.vector";
import type { View } from "../view/View";
import type { Viewer } from "../view/Viewer";
export declare const InteractorType: {
    readonly None: 0;
    readonly Dragger: 1;
    readonly Button: 2;
};
export type InteractorType = typeof InteractorType[keyof typeof InteractorType];
export declare class Interactor {
    get element(): HTMLElement;
    get visible(): boolean;
    set visible(pValue: boolean);
    get type(): InteractorType;
    set type(pValue: InteractorType);
    position: Vector3;
    posOffsetDirection: Vector3 | null;
    posOffset: number;
    worldMatrix: Matrix | null;
    customCssTransform: string;
    transform3d: boolean;
    transform3dRotation: Quaternion | null;
    onTriggerAction: (() => void) | null;
    onBeforeUpdateViewPosition: ((pView: View) => void) | null;
    constructor(pElement: HTMLElement, pViewer: Viewer);
    updateViewPosition(): boolean;
    protected mElement: HTMLElement;
    protected mViewer: Viewer;
    protected mView: View | null;
    private static MIRROR_X_MATRIX;
    private mVisible;
    private mType;
    private mManager;
    private mDisableUpdate;
    private mPendingNewView;
    private mPendingAnimationFrame;
    private updateVisibility;
    private getCssTranformMatrix;
    private onClick;
    private onPointerDown;
    private onMouseWheel;
    private onContextMenu;
    private trigger;
}
