import type { View } from "../view/View";
import type { Viewer } from "../view/Viewer";
import type { Interactor } from "./Interactor";
export declare class InteractorManager {
    get enabled(): boolean;
    set enabled(pValue: boolean);
    get interactors(): ReadonlyArray<Interactor>;
    get viewer(): Viewer;
    get view(): View | null;
    constructor(pViewer: Viewer);
    addInteractor(pInteractor: Interactor): void;
    removeInteractor(pInteractor: Interactor): void;
    clear(): void;
    dispose(): void;
    private mInteractors;
    private mView;
    private mViewer;
    private mEnabled;
    private onCameraChanged;
    private setEnabled;
    private setView;
    private addInteractorsToView;
    private removeInteractorsFromView;
}
