import { Vector3 } from "@babylonjs/core/Maths/math.vector";
import type { View } from "../view/View";
export interface SnapResult {
    line: SnapLine;
    pos: Vector3;
}
export declare class SnapLine {
    get point1(): Vector3;
    get point2(): Vector3;
    get direction(): Vector3;
    isSegment: boolean;
    locked: boolean;
    constructor(pPoint1: Vector3, pPoint2: Vector3, pIsSegment?: boolean);
    setPoint1(pPoint: Vector3): void;
    setPoint2(pPoint: Vector3): void;
    static FromAxis(pOrigin: Vector3, pAxis: Vector3): SnapLine;
    /**
     * Find nearest snap line. If pView is null pSnapDistance will be handled as meter otherwise as pixel.
     */
    static Snap(pPos: Vector3, pLines: Array<SnapLine>, pView: View | null, pSnapDistance?: number): SnapResult | null;
    private mPoint1;
    private mPoint2;
    private mDirection;
    private updateDirection;
}
