import { ListenableEvent } from "../../utils";
import type { Interactor } from "./Interactor";
import type { Tool } from "./Tool";
export declare class ToolManager {
    get activeTool(): Tool | null;
    get defaultTool(): Tool | null;
    set defaultTool(pTool: Tool | null);
    readonly eventToolStarted: ListenableEvent<Tool, ToolManager>;
    readonly eventToolStopped: ListenableEvent<Tool, ToolManager>;
    readonly eventInteractorTriggered: ListenableEvent<Interactor, ToolManager>;
    constructor();
    /**
     * Starts pTool and stops the current active tool.
     */
    startTool(pTool: Tool, pToolParameter?: unknown): boolean;
    stopActiveTool(): void;
    startDefaultTool(): boolean;
    isDefaultToolRunning(): boolean;
    private mDefaultTool;
    private mActiveTool;
    private mActiveDraggerInteractor;
    private mActiveDraggerPointerId;
    private stopTool;
    private getActiveRunningTool;
    private finishInteractorDragging;
}
