import { Effect } from "@babylonjs/core/Materials/effect";
import type { Material } from "@babylonjs/core/Materials/material";
import { Color4 } from "@babylonjs/core/Maths/math.color";
import type { Vector3 } from "@babylonjs/core/Maths/math.vector";
import type { InstancedMesh } from "@babylonjs/core/Meshes/instancedMesh";
import { Mesh } from "@babylonjs/core/Meshes/mesh";
import type { SubMesh } from "@babylonjs/core/Meshes/subMesh";
import type { Node } from "@babylonjs/core/node";
import type { Scene } from "@babylonjs/core/scene";
export declare class ThickLinesMesh extends Mesh {
    color: Color4;
    thickness: number;
    constructor(pName: string, pScene: Scene, pParent?: Node | null, pSource?: ThickLinesMesh, pDoNotCloneChildren?: boolean);
    get material(): Material;
    set material(pValue: Material);
    get checkCollisions(): boolean;
    set checkCollisions(pValue: boolean);
    getClassName(): string;
    createInstance(name: string): InstancedMesh;
    _bind(pSubMesh: SubMesh, pEffect: Effect, pFillMode: number): ThickLinesMesh;
    dispose(pDoNotRecurse?: boolean, pDisposeMaterialAndTextures?: boolean): void;
    clone(pName: string, pNewParent?: Node | null, pDoNotCloneChildren?: boolean): ThickLinesMesh;
    static CreateThickLines(pName: string, pScene: Scene, pLines: Array<Vector3>): ThickLinesMesh;
    private _lineMaterial;
    private _lastViewportSize;
    private onBeforeCameraRender;
}
