import type { SoapErrorDetail } from "../SoapService";
import { SoapRequestData } from "../SoapService";
export type AttachmentMode = "None" | "Item" | "Composite" | "TryComposite";
export type ArticleDescriptionMode = "Short" | "Long" | "Both";
export type Axis = "X" | "Y" | "Z";
export type BasketItemAttrId = "Undefined" | "UserDefined" | "Manufacturer" | "Series" | "ArticleNumber" | "Description" | "Quantity" | "SinglePurchasePrice" | "TotalPurchasePrice" | "SingleSalesPrice" | "TotalSalesPrice" | "SingleNetPrice" | "TotalNetPrice" | "SingleGrossPrice" | "TotalGrossPrice" | "Position" | "CatalogImage" | "GeneratedImage" | "ArticleImage";
export type BasketItemType = "Undefined" | "Folder" | "Article" | "Aggregate" | "PartialPlanning" | "UserArticle" | "SetArticle" | "OCDArticle" | "Text";
export type CalculationRule = "Invalid" | "Percent" | "FixedAmount" | "Quantity" | "GrossWeight" | "NetWeight" | "Volume" | "Rounding";
export type CollatorDecomposition = "None" | "Canonical" | "Full";
export type CollatorStrength = "Primary" | "Secondary" | "Tertiary" | "Identical";
export type ColumnType = "Undefined" | "Builtin" | "Text" | "Number" | "Boolean" | "Image" | "EClass";
export type ConditionClass = "Price" | "PriceModifier" | "Tax";
export type ConditionEditMode = "Never" | "IfCondRecFound" | "IfCondRecNotFound" | "ManualWithDefault" | "Manual";
export type ConditionSign = "NoRestriction" | "Negative" | "Positive";
export type CSValueKind = "Other" | "ItemQuantity" | "SalesUnitSize" | "SalesUnitGrossWeight" | "SalesUnitNetWeight" | "SalesUnitVolume" | "InactiveItemFlag" | "SetArticleIdentifier" | "CondRecordAmount" | "Incoming" | "Reference" | "Outgoing" | "CondBase" | "ScaleBase" | "CondAmount" | "DefaultQtyRel" | "QuantityRelation" | "CondBaseQtyRelRatio" | "CondValue" | "SubtotalValue" | "SetArticleQty" | "GroupCondBase" | "AltGroupCondBase" | "GroupScaleBase" | "GroupAmount" | "CondBaseRatio" | "GroupValue" | "GroupValueResidue" | "AggrIncoming" | "AggrReference" | "AggrOutgoing" | "AggrCondBase" | "AggrCondValue" | "AggrSubtotalValue" | "AggrSetArticleQtys";
export type CSErrorCode = "InconsistentItemState" | "UnknownItemDataAccessError" | "UndefinedValue" | "InvalidValue" | "InfiniteValue" | "NullValue" | "PercentageExpected" | "MonetaryValueExpected" | "MonetaryBaseExpected" | "QuantityBaseExpected" | "UnknownValue" | "UnknownCurrency" | "CurrencyConversionFailed" | "CurrencyMismatch" | "ConformabilityError" | "DivisionByZero" | "Overflow" | "InvalidOperation" | "NoPreviousLine" | "ReferencedLineNotFound" | "NoInversePriceCalculation" | "UndefinedInverseGroupConditionCalculation";
export type CSOperationKind = "Add" | "Subtract" | "Multiply" | "Divide" | "Remainder" | "CurrencyConversion" | "UnitConversion";
export type DescrType = "Default" | "Short" | "Long" | "Features" | "Extra" | "PreferUserDescr";
export type Dimension = "X" | "Y" | "Z" | "PX" | "PY" | "PZ" | "NX" | "NY" | "NZ";
export type GetItemPropertiesTextMode = "Legacy" | "Simple" | "Multi" | "Mixed";
export type HalfWayRoundingMode = "Even" | "Up";
export type InactiveFlag = "NoData" | "SubsequentPrice";
export type LineInsertMode = "Always" | "Manual" | "Auto";
export type LineType = "Condition" | "Subtotal" | "Text" | "CalculationBreak";
export type MergeMode = "None" | "Articles" | "Composites" | "CompositesStrict" | "SubArticles" | "Compact" | "ArticlesCompact";
export type MoveItemsDirection = "Up" | "Down" | "Indent" | "Unindent";
export type MoveItemsResult = "Done" | "NothingToDo" | "NoConsecutiveItemSequence" | "NoPredecessor" | "NoSuccessor" | "HasSuccessor" | "NoGrandparent" | "CannotChangePlanningItemIndentation" | "NewParentHasInappropriateType";
export type OAPActionState = "Disabled" | "Enabled" | "Success" | "Failure" | "NotResponsible";
export type OAPArticleSpecMode = "Self" | "Explicit";
export type OAPClientCapability = "MultiActionChoice" | "PlanningMode";
export type OAPMediaSource = "PIM" | "YouTube";
export type OAPMethodCallType = "Instance" | "Class";
export type OAPObjectCategory = "Self" | "ParentArticle" | "TopArticle" | "SubArticles" | "SubArticlesDeep" | "SubArticle" | "Article" | "Attached" | "AttachedRecursive" | "AttachedArea" | "AttachedAreaRecursive" | "AttachedArticle" | "MethodCall";
export type OAPPropChangeType = "Value" | "Visibility" | "Editability";
export type OAPSymbolSize = "Small" | "Medium" | "Large";
export type OAPSymbolType = "Add" | "Delete" | "Edit" | "Flip" | "RotatePY" | "RotateNY" | "RotateNY90" | "RotatePY90" | "Material" | "ChangeDimHorizontal" | "ChangeDim2Left" | "ChangeDim2Right" | "ChangeDimVertical" | "ChangeDimDown" | "ChangeDimUp" | "PosHorizontal" | "Pos2Left" | "Pos2Right" | "PosVertical" | "PosDown" | "PosUp" | "OnOff" | "StartDimChange" | "Video" | "Attention" | "Electrification" | "Lighting" | "PropChange" | "PropEdit" | "CreateChild" | "CreateChildren" | "CreateSibling" | "CreateSiblings" | "DeleteObj" | "Transform" | "Translate" | "Rotate" | "RotatePX" | "RotateNX" | "RotateX180" | "RotateY180" | "RotatePZ" | "RotateNZ" | "RotateZ180" | "Logics" | "CheckRules" | "Info" | "Other" | "MovePlane" | "MoveAxis" | "MoveDir";
export type OAPTileSize = "Small" | "Medium" | "Large";
export type OAPViewType = "List" | "Tile";
export type OFMLUpdateState = "Unknown" | "UpToDate" | "Updatable" | "Migratable" | "Invalid" | "NoCatalog" | "MultipleCatalogs";
export type PlanningDirection = "Right_Front" | "Right_Back" | "Left_Front" | "Left_Back" | "Front_Right" | "Front_Left" | "Back_Right" | "Back_Left";
export type PrintControl = "Never" | "PositionAlways" | "PositionNonZero" | "PositionChanged" | "PositionChangedNonZero" | "HeaderAlways" | "HeaderNonZero" | "HeaderChanged" | "HeaderChangedNonZero";
export type PropertyType = "Character" | "Numeric" | "Length";
export type RelocateItemsResult = "Done" | "NothingToDo" | "CannotReparentPlanningItem" | "NewParentHasInappropriateType" | "IllegalStructuralChange";
export type RoundingRule = "NoRounding" | "RoundToNearest" | "RoundUp" | "RoundDown";
export type SetArticleMode = "Expand" | "Collapse" | "Dynamic";
export type SetLanguagesMode = "Default" | "CurrentProject" | "AllProjects";
export type SpatialPlanningDirection = "Horizontal" | "Vertical";
export type TMColumnId = "Undefined" | "Identifier" | "Name" | "Language" | "Text" | "Visible";
export type TMTextType = "Undefined" | "Short" | "Long" | "Features" | "Extra";
export type ViewDisplayMode = "Undefined" | "Sorted" | "Planning";
export type IsoDateString = string;
export declare class AddStateCode extends SoapRequestData {
    value: string;
    domain: string;
    constructor();
    static FromSoapArray(pSoapArray: any): Array<AddStateCode> | undefined;
    static FromSoapNU(this: void, pSoapData: any): AddStateCode;
}
export declare class ArticleClassification extends SoapRequestData {
    description?: Array<DisplayText>;
    system: string;
    qualifier?: string;
    classId: string;
    constructor();
    static FromSoapArray(pSoapArray: any): Array<ArticleClassification> | undefined;
    static FromSoapNU(this: void, pSoapData: any): ArticleClassification;
}
export declare class ArticleDescription extends SoapRequestData {
    shortText?: Array<DisplayText>;
    longText?: Array<DisplayText>;
    featureText?: Array<DisplayText>;
    static FromSoap(pSoapData: any): ArticleDescription | undefined;
}
export declare class ArticleProperties extends SoapRequestData {
    catalogId?: string;
    manufacturerId?: string;
    manufacturerName?: string;
    seriesId?: string;
    seriesName?: string;
    manufacturer?: string;
    program?: string;
    distributionRegion?: string;
    baseArticleNumber?: string;
    finalArticleNumber?: string;
    variantCode?: string;
    ofmlVariantCode?: string;
    useFinalArticleNumber?: boolean;
    shortText?: string;
    longText?: string;
    featureText?: string;
    descriptionMode?: ArticleDescriptionMode;
    productDescription?: ArticleDescription;
    userDescription?: ArticleDescription;
    currency?: string;
    purchaseCurrency?: string;
    salesCurrency?: string;
    purchasePrice?: number;
    salesPrice?: number;
    priceDateSupported?: boolean;
    priceDateEditable?: boolean;
    priceDate?: IsoDateString;
    quantity?: number;
    alternativePosition?: boolean;
    excludedCalculations?: Array<string>;
    inactivePositionState?: Array<InactivePositionState>;
    inconsistencyFlag?: boolean;
    inconsistencyReason?: Array<string>;
    priceInfo?: PriceInfo;
    packagingInfo?: PackagingInfo;
    pseudoArticle?: boolean;
    nonOfferArticle?: boolean;
    nonOrderArticle?: boolean;
    articleClassifications?: Array<ArticleClassification>;
    ofmlUpdateState?: OFMLUpdateState;
    geometryId?: string;
    subArticles?: Array<ArticleProperties>;
    addStateCodes?: Array<AddStateCode>;
    static FromSoapArray(pSoapArray: any): Array<ArticleProperties> | undefined;
    static FromSoap(pSoapData: any): ArticleProperties | undefined;
    static FromSoapNU(this: void, pSoapData: any): ArticleProperties;
}
export declare class BasketColumn extends SoapRequestData {
    name?: string;
    title?: string;
    defaultValue?: string;
    id: string;
    type?: ColumnType;
    itemAttrId?: BasketItemAttrId;
    removable?: boolean;
    editable?: boolean;
    defaultColumn?: string;
    minWidth?: number;
    weight?: number;
    readOnly?: boolean;
    constructor();
    static FromSoapArrayNU(pSoapArray: any): Array<BasketColumn>;
    static FromSoap(pSoapData: any): BasketColumn | undefined;
    static FromSoapNU(this: void, pSoapData: any): BasketColumn;
}
export declare class BasketConfig extends SoapRequestData {
    viewIds?: Array<string>;
    columnIds?: Array<string>;
    obkVersionInfo?: OBKVersionInfo;
    defaultView?: string;
    columnsEditable?: boolean;
    currency?: string;
    currencyEditable?: boolean;
    defaultPriceDate?: IsoDateString;
    static FromSoap(pSoapData: any): BasketConfig | undefined;
}
export declare class BasketViewConfig extends SoapRequestData {
    name?: string;
    visibleColumns?: Array<string>;
    columnWidths?: Array<ColumnWidth>;
    sortConfig?: BasketViewSortConfig;
    articleDescrMode?: Array<DescrType>;
    viewId: string;
    removable?: boolean;
    editable?: boolean;
    displayMode?: ViewDisplayMode;
    expandGroups?: boolean;
    expandPlanningFolders?: boolean;
    expandBasketFolders?: boolean;
    expandPartialPlannings?: boolean;
    expandAggregates?: boolean;
    textItemsVisible?: boolean;
    nonOfferArticlesVisible?: boolean;
    nonOrderArticlesVisible?: boolean;
    mergeMode?: MergeMode;
    autoColumnWidth?: boolean;
    hiddenDiscounts?: boolean;
    setArticleMode?: SetArticleMode;
    constructor();
    static FromSoapArrayNU(pSoapArray: any): Array<BasketViewConfig>;
    static FromSoap(pSoapData: any): BasketViewConfig | undefined;
    static FromSoapNU(this: void, pSoapData: any): BasketViewConfig;
}
export declare class BasketViewSortConfig extends SoapRequestData {
    groups?: Array<SortGroup>;
    collatorStrength?: CollatorStrength;
    collatorDecomposition?: CollatorDecomposition;
    static FromSoap(pSoapData: any): BasketViewSortConfig | undefined;
}
export declare class ColumnSortOrder extends SoapRequestData {
    columnId: string;
    ascending?: boolean;
    undefinedFirst?: boolean;
    constructor();
    static FromSoapArray(pSoapArray: any): Array<ColumnSortOrder> | undefined;
    static FromSoapNU(this: void, pSoapData: any): ColumnSortOrder;
}
export declare class ColumnWidth extends SoapRequestData {
    columnId: string;
    width: number;
    constructor();
    static FromSoapArray(pSoapArray: any): Array<ColumnWidth> | undefined;
    static FromSoapNU(this: void, pSoapData: any): ColumnWidth;
}
export declare class ComposableGeometryProperties extends SoapRequestData {
    enabled?: boolean;
    position?: Vector3;
    rotation?: Rotation;
    scale?: Vector3;
    geometry?: string;
    itemId?: string;
    static FromSoapArray(pSoapArray: any): Array<ComposableGeometryProperties> | undefined;
    static FromSoap(pSoapData: any): ComposableGeometryProperties | undefined;
    static FromSoapNU(this: void, pSoapData: any): ComposableGeometryProperties;
}
export declare class CopyOptions extends SoapRequestData {
    encoding?: string;
    suffix?: string;
    overwrite?: boolean;
    cut?: boolean;
    omitPriceData?: boolean;
}
export declare class DisplayText extends SoapRequestData {
    value: string;
    lang?: string;
    constructor();
    static FromSoapArray(pSoapArray: any): Array<DisplayText> | undefined;
    static FromSoapNU(this: void, pSoapData: any): DisplayText;
}
export declare class ExchangeRate extends SoapRequestData {
    currency: string;
    rate?: number;
    constructor();
    static FromSoapArrayNU(pSoapArray: any): Array<ExchangeRate>;
    static FromSoapNU(this: void, pSoapData: any): ExchangeRate;
}
export declare class FolderProperties extends SoapRequestData {
    name?: string;
    displayName?: Array<DisplayText>;
    longDisplayText?: Array<DisplayText>;
    showSubTotal?: boolean;
    static FromSoap(pSoapData: any): FolderProperties | undefined;
}
export declare class GetArticleDataOptions extends SoapRequestData {
    noProperties?: boolean;
    fetchCatalogImage?: boolean;
    fetchCatalogIcon?: boolean;
    viewId?: string;
    separateCurrencies?: boolean;
    highResPropValueIcons?: boolean;
    fetchPropValueImages?: boolean;
}
export declare class GetArticleFeaturesOptions extends SoapRequestData {
    description?: boolean;
    noInternal?: boolean;
}
export declare class GetChoiceListOptions extends SoapRequestData {
    convertSurcharge?: boolean;
    formatSurcharge?: boolean;
    discardSurcharge?: boolean;
    highResPropValueIcons?: boolean;
    fetchPropValueImages?: boolean;
}
export declare class InactivePositionState extends SoapRequestData {
    ppName: string;
    optional?: boolean;
    constructor();
    static FromSoapArray(pSoapArray: any): Array<InactivePositionState> | undefined;
    static FromSoapNU(this: void, pSoapData: any): InactivePositionState;
}
export declare class InsertArticleOptions extends SoapRequestData {
    noComplexType?: boolean;
    attachmentMode?: AttachmentMode;
    planarPlanningDirection?: PlanningDirection;
    spatialPlanningDirection?: SpatialPlanningDirection;
    strictVarCode?: boolean;
    migrate?: boolean;
    attachPoint?: string;
}
export declare class InsertInfo extends SoapRequestData {
    articlePackageId?: string;
    baseArticleNumber: string;
    catalogId?: string;
    catalogPackageId?: string;
    manufacturerId?: string;
    ofmlVariantCode?: string;
    seriesId?: string;
    variantCode?: string;
    constructor();
}
export declare class ItemProperties extends SoapRequestData {
    itemId?: string;
    itemType?: BasketItemType;
    visible?: boolean;
    expanded?: boolean;
    label?: string;
    setArticleId?: string;
    tmRows?: Array<TMRow>;
    tmDescription?: string;
    composableGeometry?: ComposableGeometryProperties;
    composableGeometries?: Array<ComposableGeometryProperties>;
    folder?: FolderProperties;
    article?: ArticleProperties;
    setArticle?: SetArticleProperties;
    textItem?: TextItemProperties;
    positionNumber?: string;
    static FromSoapArrayNU(pSoapArray: any): Array<ItemProperties>;
    static FromSoapNU(this: void, pSoapData: any): ItemProperties;
}
export declare class ItemSelectionOptions extends SoapRequestData {
    wholeComposite?: boolean;
    subItems?: boolean;
    parentItems?: boolean;
    viewId?: string;
}
export declare class DeleteItemsOptions extends ItemSelectionOptions {
    subArticles?: boolean;
}
export declare class GetAllItemsOptions extends ItemSelectionOptions {
    setArticleIds?: boolean;
    geometryIds?: boolean;
    positionNumbers?: boolean;
    basketItems?: boolean;
}
export declare class GetImagesOptions extends ItemSelectionOptions {
    useCache?: boolean;
    generate?: boolean;
    itemIds?: boolean;
    attributes?: boolean;
}
export declare class GetItemFieldsOptions extends ItemSelectionOptions {
    useDefault?: boolean;
    expandVariables?: boolean;
    resolveURI?: boolean;
    useImageCache?: boolean;
    generateImages?: boolean;
}
export declare class GetItemPropertiesOptions extends ItemSelectionOptions {
    tmDescrMode?: Array<DescrType>;
    extraPriceInfoSelectors?: Array<string>;
    priceInfo?: boolean;
    pricingProcedureName?: string;
    positionNumbers?: boolean;
    addStateCodes?: boolean;
    textMode?: GetItemPropertiesTextMode;
    preferUserDescriptions?: boolean;
    separateCurrencies?: boolean;
    inactivePositionState?: boolean;
    articleClassifications?: boolean;
    includeCalculationErrorsInInconsistencies?: boolean;
}
export declare class GetManufacturerInfoOptions extends ItemSelectionOptions {
    allData?: boolean;
    allLanguages?: boolean;
    manufacturerName?: boolean;
    seriesInfo?: boolean;
    seriesName?: boolean;
    manufacturerConfig?: boolean;
    distributorName?: boolean;
    copyright?: boolean;
    address?: boolean;
    externalCatalog?: boolean;
}
export declare class CondGroupSelectionOptions extends ItemSelectionOptions {
    excludeInactiveItems?: boolean;
    includeInactiveItems?: boolean;
}
export declare class GetPriceCalculationSheetOptions extends CondGroupSelectionOptions {
    sumUpComposite?: boolean;
    itemCondAmountPerUnit?: boolean;
    headerCondAmountPerUnit?: boolean;
}
export declare class ItemField extends SoapRequestData {
    data: string;
    itemId: string;
    columnId: string;
    constructor();
    static FromSoapArrayNU(pSoapArray: any): Array<ItemField>;
    static FromSoapNU(this: void, pSoapData: any): ItemField;
}
export declare class UpdateBasketArticlesOptions extends ItemSelectionOptions {
    update?: boolean;
    migrate?: boolean;
    recalculate?: boolean;
    priceDate?: IsoDateString;
}
export declare class OAPActionContext extends SoapRequestData {
    self: string;
    interactor?: string;
    dpr?: number;
    constructor();
}
export declare class OBKVersionInfo extends SoapRequestData {
    vendorKey: string;
    appKey: string;
    appVersion: string;
    bskXmlVersion: string;
    bskVersion?: string;
    constructor();
    static FromSoap(pSoapData: any): OBKVersionInfo | undefined;
}
export declare class OperationMode extends SoapRequestData {
    subPositions?: boolean;
    mainArticles?: boolean;
    breakUpSetArticles?: boolean;
    migrate?: boolean;
}
export declare class PackagingInfo extends SoapRequestData {
    width?: Quantity;
    height?: Quantity;
    depth?: Quantity;
    volume?: Quantity;
    tareWeight?: Quantity;
    netWeight?: Quantity;
    itemsPerPackUnit?: number;
    packUnitsPerArticle?: number;
    static FromSoap(pSoapData: any): PackagingInfo | undefined;
}
export declare class RelocateItemsOptions extends SoapRequestData {
    doNotModify?: boolean;
    flat?: boolean;
}
export declare class PasteOptions extends SoapRequestData {
    reuseItemIds?: boolean;
    returnOriginalItemIds?: boolean;
    ignoreComposableGeometries?: boolean;
}
export declare class PasteContainerOptions extends PasteOptions {
    setArticleIds?: boolean;
    geometryIds?: boolean;
}
export declare class Rotation extends SoapRequestData {
    axis: Vector3;
    angle: number;
    constructor();
    static FromSoap(pSoapData: any): Rotation | undefined;
}
export declare class SetArticleProperties extends SoapRequestData {
    partIds?: Array<string>;
    allPartIds?: Array<string>;
    collapsed?: boolean;
    static FromSoap(pSoapData: any): SetArticleProperties | undefined;
}
export declare class SetPropertyValueOptions extends SoapRequestData {
    computeVisibilityChangeFlags?: boolean;
    computeValueChangeFlags?: boolean;
    computeChoiceListChangeFlags?: boolean;
}
export declare class SortGroup extends SoapRequestData {
    selector?: Array<SortGroupSelector>;
    sortOrder?: Array<ColumnSortOrder>;
    position: number;
    constructor();
    static FromSoapArray(pSoapArray: any): Array<SortGroup> | undefined;
    static FromSoapNU(this: void, pSoapData: any): SortGroup;
}
export declare class SortGroupSelector extends SoapRequestData {
    itemType?: BasketItemType;
    itemId?: string;
    static FromSoapArray(pSoapArray: any): Array<SortGroupSelector> | undefined;
    static FromSoapNU(this: void, pSoapData: any): SortGroupSelector;
}
export declare class TextItemProperties extends SoapRequestData {
    text?: string;
    displayText?: Array<DisplayText>;
    longDisplayText?: Array<DisplayText>;
    static FromSoap(pSoapData: any): TextItemProperties | undefined;
}
export declare class Vector3 extends SoapRequestData {
    x: number;
    y: number;
    z: number;
    constructor();
    static FromSoap(pSoapData: any): Vector3 | undefined;
    static FromSoapNU(this: void, pSoapData: any): Vector3;
}
export declare class Value extends SoapRequestData {
    value?: number;
    static FromSoap(pSoapData: any): Value | undefined;
}
export declare class Money extends Value {
    currency: string;
    constructor();
    static FromSoap(pSoapData: any): Money | undefined;
}
export declare class Percentage extends Value {
}
export declare class Quantity extends Value {
    unit: string;
    constructor();
    static FromSoap(pSoapData: any): Quantity | undefined;
}
export declare class ArticleData {
    baseArticleNumber: string;
    catalogIcon?: string;
    catalogImage?: string;
    currency?: string;
    descriptionMode: ArticleDescriptionMode;
    featureText: string;
    longText: string;
    manufacturerId: string;
    pdPurchasePrice?: number;
    pdPurchasePriceComponents?: Array<PriceComponent>;
    pdSalesPrice?: number;
    pdSalesPriceComponents?: Array<PriceComponent>;
    properties?: Array<Property>;
    propertyClasses?: Array<PropertyClass>;
    seriesId: string;
    shortText: string;
    variantCode: string;
    purchaseCurrency?: string;
    salesCurrency?: string;
    priceDateSupported: boolean;
    priceDateEditable: boolean;
    priceDate?: IsoDateString;
    getProperty(pPropClass: string, pPropName: string): Property | null;
    getPropertyValue(pPropClass: string, pPropName: string): PropertyValue | null;
    static FromSoapNU(this: void, pSoapData: any): ArticleData;
}
export declare class ArticleFeature {
    displayName?: string;
    displayValue?: string;
    symbolicName?: string;
    symbolicValue?: string;
    visible: boolean;
    static FromSoapArrayNU(pSoapArray: any): Array<ArticleFeature>;
    static FromSoapNU(this: void, pSoapData: any): ArticleFeature;
}
export declare class BasketItem {
    itemId: string;
    itemType: BasketItemType;
    label: string;
    mainArticleId?: string;
    subArticleIds?: Array<string>;
    subItemIds?: Array<string>;
    setArticlePartIds?: Array<string>;
    basketItemIds?: Array<string>;
    basketItems?: Array<BasketItem>;
    setArticleId?: string;
    geometryId?: string;
    positionNumber?: string;
    /**
     * Returns this.mainArticleId if it is a valid id or this.itemId otherwise.
     * Returns undefined if this.mainArticleId is undefined.
     */
    getMainArticleId(): string | undefined;
    static FromSoapArray(pSoapArray: any): Array<BasketItem> | undefined;
    static FromSoapArrayNU(pSoapArray: any): Array<BasketItem>;
    static FromSoapNU(this: void, pSoapData: any): BasketItem;
}
export declare class BasketServiceFault implements SoapErrorDetail {
    message?: string;
    partCompositionFailures?: Array<PartCompositionFailure>;
    static FromSoap(pSoapData: any): BasketServiceFault | undefined;
}
export declare class CalculationLine {
    inactive?: Array<InactiveFlag>;
    description: string;
    amount?: Value;
    qtyRelation?: Quantity;
    value?: Money;
    level: number;
    groupError?: CSValidationError;
    error?: CSValidationError;
    counter: number;
    conditionType?: string;
    conditionRemovable: boolean;
    amountEditable: boolean;
    amountEdited?: boolean;
    qtyRelationEditable: boolean;
    valueEditable: boolean;
    static FromSoapArrayNU(pSoapArray: any): Array<CalculationLine>;
    static FromSoapNU(this: void, pSoapData: any): CalculationLine;
}
export declare class CalculationSheet {
    quantity?: Quantity;
    netValue?: Money;
    tax?: Money;
    lines: Array<CalculationLine>;
    addableConditions: Array<string>;
    currency: string;
    static FromSoapNU(this: void, pSoapData: any): CalculationSheet;
}
export declare class ChoiceList {
    propClass: string;
    propName: string;
    values?: Array<PropertyValue>;
    static FromSoapArrayNU(pSoapArray: any): Array<ChoiceList>;
    static FromSoapNU(this: void, pSoapData: any): ChoiceList;
}
export declare class ConditionType {
    description: string;
    accessMethod?: string;
    amountEditable: boolean;
    calculationRule: CalculationRule;
    calculationRuleEditable: boolean;
    conditionClass: ConditionClass;
    conditionDeletable: boolean;
    conditionSign: ConditionSign;
    deferredCurrencyConversionEnabled: boolean;
    editMode: ConditionEditMode;
    groupCondition: boolean;
    headerCondition: boolean;
    name: string;
    quantityRelationEditable: boolean;
    roundingRule: RoundingRule;
    valueEditable: boolean;
    static FromSoapArrayNU(pSoapArray: any): Array<ConditionType>;
    static FromSoapNU(this: void, pSoapData: any): ConditionType;
}
export declare class CSValidationError {
    message: string;
    resultKind: CSValueKind;
    errorCode: CSErrorCode;
    static FromSoap(pSoapData: any): CSValidationError | undefined;
    static FromSoapNU(this: void, pSoapData: any): OAPAction;
}
export declare class CSArithmeticOperationError extends CSValidationError {
    operationKind: CSOperationKind;
}
export declare class CSConformabilityError extends CSValidationError {
    operationKind: CSOperationKind;
    unit1: string;
    unit2: string;
}
export declare class CSCurrencyError extends CSValidationError {
    operationKind: CSOperationKind;
    currency1: string;
    currency2: string;
}
export declare class CSInvalidValueError extends CSValidationError {
    parameterKind: CSValueKind;
}
export declare class CSItemDataAccessError extends CSValidationError {
}
export declare class CSLineNotFoundError extends CSValidationError {
}
export declare class CSUndefinedOperationError extends CSValidationError {
    calculationRule: CalculationRule;
}
export declare class ImageInfo {
    tag: string;
    url: string;
    attributes?: Array<string>;
    itemId?: string;
    static FromSoapArrayNU(pSoapArray: any): Array<ImageInfo>;
    static FromSoapNU(this: void, pSoapData: any): ImageInfo;
}
export declare class Interval {
    maxValue: number;
    minValue: number;
    static FromSoapArray(pSoapArray: any): Array<Interval> | undefined;
    static FromSoapNU(this: void, pSoapData: any): Interval;
}
export declare class ItemCalculationSheet {
    id: string;
    sheet: CalculationSheet;
    static FromSoapArrayNU(pSoapArray: any): Array<ItemCalculationSheet>;
    static FromSoapNU(this: void, pSoapData: any): ItemCalculationSheet;
}
export declare class ManufacturerInfo {
    manufacturerId: string;
    concernId?: string;
    supplierId?: string;
    priceProfileRegionId?: string;
    manufacturerName?: Array<DisplayText>;
    seriesInfos?: Array<SeriesInfo>;
    distributorName?: Array<DisplayText>;
    copyright?: Array<DisplayText>;
    addressName?: Array<DisplayText>;
    addressStreet?: Array<DisplayText>;
    addressCity?: Array<DisplayText>;
    addressState?: Array<DisplayText>;
    addressPOBox?: Array<DisplayText>;
    addressZIP?: Array<DisplayText>;
    addressCountry?: Array<DisplayText>;
    addressEMail?: Array<DisplayText>;
    addressPhone?: Array<DisplayText>;
    addressFAX?: Array<DisplayText>;
    addressWWW?: Array<DisplayText>;
    externalCatalogURL?: string;
    externalCatalogName?: Array<DisplayText>;
    static FromSoapArrayNU(pSoapArray: any): Array<ManufacturerInfo>;
    static FromSoapNU(this: void, pSoapData: any): ManufacturerInfo;
}
export declare class MergeResult {
    addedItems?: Array<string>;
    removedItems?: Array<string>;
    movedItems?: Array<string>;
    updatedItems?: Array<string>;
    static FromSoapNU(this: void, pSoapData: any): MergeResult;
}
export declare class OAPAction {
    objects?: Array<OAPObjectDefinition>;
    id: string;
    static FromSoap(pSoapData: any): OAPAction | undefined;
    static FromSoapNU(this: void, pSoapData: any): OAPAction;
}
export declare class OAPActionChoiceAction extends OAPAction {
    title?: string;
    actions: Array<OAPActionListItem>;
    viewType: OAPViewType;
    tileSize?: OAPTileSize;
}
export declare class OAPCreateObjectAction extends OAPAction {
    parent?: OAPObjectDefinition;
    ofmlVariantCode?: string;
    initialPlacement: OAPPlacement;
    articleSpecMode: OAPArticleSpecMode;
    packageId?: string;
    baseArticleNumber?: string;
}
export declare class OAPDeleteObjectAction extends OAPAction {
}
export declare class OAPDimChangeAction extends OAPAction {
    dimChanges?: Array<OAPDimChange>;
}
export declare class OAPDimChange2Action extends OAPAction {
    dimChanges?: Array<OAPDimChange>;
}
export declare class OAPMethodCallAction extends OAPAction {
    type: OAPMethodCallType;
    context: string;
    method: string;
    arguments: string;
}
export declare class OAPMessageAction extends OAPAction {
    text: string;
}
export declare class OAPPropChangeAction extends OAPAction {
    type: OAPPropChangeType;
    property: string;
    value: string;
}
export declare class OAPPropEditAction extends OAPAction {
    title: string;
    properties?: Array<string>;
    propertyClasses?: Array<string>;
    visibleOnly: boolean;
    editableOnly: boolean;
}
export declare class OAPPropEdit2Action extends OAPAction {
    title: string;
    properties?: Array<OAPPropEditProp>;
    propertyClasses?: Array<OAPPropEditClass>;
}
export declare class OAPSelectObjectAction extends OAPAction {
}
export declare class OAPShowMediaAction extends OAPAction {
    mediaSource: OAPMediaSource;
    mediaId: string;
}
export declare class OAPActionResult {
    actionData?: OAPAction;
    objects?: Array<string>;
    referenceObject?: string;
    newObjectPosition?: Vector3;
    newObjectRotation?: Rotation;
    addedItems?: Array<string>;
    removedItems?: Array<string>;
    movedItems?: Array<string>;
    updatedItems?: Array<string>;
    id: string;
    state: OAPActionState;
    static FromSoapArray(pSoapArray: any): Array<OAPActionResult> | undefined;
    static FromSoapArrayNU(pSoapArray: any): Array<OAPActionResult>;
    static FromSoapNU(this: void, pSoapData: any): OAPActionResult;
}
export declare class OAPActionListItem {
    /**
     * Only available if OAP client capability `MultiActionChoice` is not set.
     * see `BasketService.oapSetClientCapabilities()`
     */
    action?: OAPAction;
    /**
     * Only available if OAP client capability `MultiActionChoice` is set.
     * see `BasketService.oapSetClientCapabilities()`
     */
    actionIds?: Array<string>;
    text?: string;
    imageFile?: string;
    static FromSoapArrayNU(pSoapArray: any): Array<OAPActionListItem>;
    static FromSoapNU(this: void, pSoapData: any): OAPActionListItem;
}
export declare class OAPDimChange {
    propChoiceList?: Array<number>;
    symbolicPropValues?: Array<string>;
    axis?: Axis;
    dimension: Dimension;
    propClass?: string;
    propName: string;
    propValue: number;
    minPropValue: number;
    maxPropValue: number;
    fixedValue: boolean;
    propDecDigits: number;
    multiplier: number;
    precision: number;
    changeSeparately: boolean;
    thirdDimension: boolean;
    static FromSoapArray(pSoapArray: any): Array<OAPDimChange> | undefined;
    static FromSoapNU(this: void, pSoapData: any): OAPDimChange;
}
export declare class OAPInteractor {
    symbolOffset?: Vector3;
    actionIds?: Array<string>;
    symbols?: Array<OAPSymbolDisplay>;
    directActionIds?: Array<string>;
    directActions?: Array<OAPActionResult>;
    id: string;
    symbolType: OAPSymbolType;
    symbolSize: OAPSymbolSize;
    static FromSoapArrayNU(pSoapArray: any): Array<OAPInteractor>;
    static FromSoapNU(this: void, pSoapData: any): OAPInteractor;
}
export declare class OAPObjectDefinition {
    arguments?: Array<string>;
    category: OAPObjectCategory;
    static FromSoapArray(pSoapArray: any): Array<OAPObjectDefinition> | undefined;
    static FromSoap(pSoapData: any): OAPObjectDefinition | undefined;
    static FromSoapNU(this: void, pSoapData: any): OAPObjectDefinition;
}
export declare class OAPPropEditClass {
    propClass: string;
    visibleOnly: boolean;
    editableOnly: boolean;
    static FromSoapArray(pSoapArray: any): Array<OAPPropEditClass> | undefined;
    static FromSoapNU(this: void, pSoapData: any): OAPPropEditClass;
}
export declare class OAPPropEditProp {
    propClass?: string;
    propName: string;
    visibleOnly: boolean;
    editableOnly: boolean;
    static FromSoapArray(pSoapArray: any): Array<OAPPropEditProp> | undefined;
    static FromSoapNU(this: void, pSoapData: any): OAPPropEditProp;
}
export declare class OAPSymbolDisplay {
    symbolOffset: Vector3;
    direction?: Vector3;
    orientationX?: Vector3;
    viewAngle?: number;
    hiddenMode?: boolean;
    static FromSoapArray(pSoapArray: any): Array<OAPSymbolDisplay>;
    static FromSoapNU(this: void, pSoapData: any): OAPSymbolDisplay;
}
export declare class OAPPlacement {
    static FromSoap(pSoapData: any): OAPPlacement | undefined;
}
export declare class OAPDataDefinedPlacement extends OAPPlacement {
    referenceObject?: OAPObjectDefinition;
    attachPoint?: string;
}
export declare class OAPAttachAreasPlacement extends OAPPlacement {
    referenceObject: OAPObjectDefinition;
    refObjectAttachAreaIds: Array<string>;
    newObjectAttachAreaId: string;
}
export declare class OrderedTax {
    order: number;
    typeId: string;
    static FromSoapArray(pSoapArray: any): Array<OrderedTax> | undefined;
    static FromSoapNU(this: void, pSoapData: any): OrderedTax;
}
export declare class PartCompositionFailure {
    itemId: string;
    cause?: Array<string>;
    static FromSoapArray(pSoapArray: any): Array<PartCompositionFailure> | undefined;
    static FromSoapNU(this: void, pSoapData: any): PartCompositionFailure;
}
export declare class PasteContainerResult {
    items: Array<BasketItem>;
    itemGeometries: Array<string>;
    originalItemIds?: Array<string>;
    sceneGeometry: string;
    static FromSoap(pSoapData: any): PasteContainerResult | undefined;
}
export declare class PriceInfo {
    unitSize: Quantity;
    netPrice?: Money;
    netValue?: Money;
    tax?: Money;
    extraPriceInfos?: Array<PriceInfoElement>;
    inactive: boolean;
    quantity: number;
    static FromSoap(pSoapData: any): PriceInfo | undefined;
}
export declare class PriceInfoElement {
    value?: Value;
    selector: string;
    static FromSoapArray(pSoapArray: any): Array<PriceInfoElement> | undefined;
    static FromSoapNU(this: void, pSoapData: any): PriceInfoElement;
}
export declare class PriceComponent {
    name: string;
    value: number;
    static FromSoapArray(pSoapArray: any): Array<PriceComponent> | undefined;
    static FromSoapNU(this: void, pSoapData: any): PriceComponent;
}
export declare class PricingProcedure {
    displayName: string;
    lines: Array<PricingProcedureLine>;
    halfWayRoundingMode: HalfWayRoundingMode;
    name: string;
    static FromSoapNU(this: void, pSoapData: any): PricingProcedure;
}
export declare class PricingProcedureDescription {
    displayName: string;
    name: string;
    static FromSoapArrayNU(pSoapArray: any): Array<PricingProcedureDescription>;
    static FromSoapNU(this: void, pSoapData: any): PricingProcedureDescription;
}
export declare class PricingProcedureLine {
    description: string;
    tags?: Array<string>;
    conditionType: string;
    counter: number;
    from?: number;
    insertMode: LineInsertMode;
    level: number;
    lineType: LineType;
    maxOccurs: number;
    printControl: PrintControl;
    to?: number;
    static FromSoapArrayNU(pSoapArray: any): Array<PricingProcedureLine>;
    static FromSoapNU(this: void, pSoapData: any): PricingProcedureLine;
}
export declare class Property {
    addValues: boolean;
    choiceList: boolean;
    decDigits: number;
    digits: number;
    editable: boolean;
    intervals?: Array<Interval>;
    propClass: string;
    propName: string;
    propText: string;
    type: PropertyType;
    value: PropertyValue;
    visible: boolean;
    width: number;
    multiLine?: boolean;
    static FromSoapArray(pSoapArray: any): Array<Property> | undefined;
    static FromSoapNU(this: void, pSoapData: any): Property;
}
export declare class PropertyClass {
    description: string;
    name: string;
    static FromSoapArray(pSoapArray: any): Array<PropertyClass> | undefined;
    static FromSoapNU(this: void, pSoapData: any): PropertyClass;
}
export declare class PropertyValue {
    largeIcon: string;
    smallIcon: string;
    surcharge?: Money;
    text: string;
    value: string;
    image?: string;
    selectable?: boolean;
    static FromSoapArray(pSoapArray: any): Array<PropertyValue> | undefined;
    static FromSoapArrayNU(pSoapArray: any): Array<PropertyValue>;
    static FromSoapNU(this: void, pSoapData: any): PropertyValue;
}
export declare class SeriesInfo {
    seriesId: string;
    seriesName?: Array<DisplayText>;
    static FromSoapArray(pSoapArray: any): Array<SeriesInfo> | undefined;
    static FromSoapNU(this: void, pSoapData: any): SeriesInfo;
}
export declare class TaxCategory {
    name: string;
    identifier: string;
    rate?: number;
    rateReadOnly: boolean;
    static FromSoapArray(pSoapArray: any): Array<TaxCategory> | undefined;
    static FromSoapNU(this: void, pSoapData: any): TaxCategory;
}
export declare class TaxInfo {
    taxCategory: string;
    taxType: string;
    static FromSoapArrayNU(pSoapArray: any): Array<TaxInfo>;
    static FromSoapNU(this: void, pSoapData: any): TaxInfo;
}
export declare class TaxScheme {
    variantName: string;
    taxTypes?: Array<TaxType>;
    orderedTaxes?: Array<OrderedTax>;
    country: string;
    currency: string;
    identifier: string;
    region: string;
    static FromSoapNU(this: void, pSoapData: any): TaxScheme;
}
export declare class TaxType {
    abbreviation: string;
    name: string;
    taxCategories?: Array<TaxCategory>;
    identifier: string;
    rateUnit: string;
    static FromSoapArray(pSoapArray: any): Array<TaxType> | undefined;
    static FromSoapNU(this: void, pSoapData: any): TaxType;
}
export declare class TaxSchemeDescription {
    variantName: string;
    country: string;
    identifier: string;
    region: string;
    static FromSoapArrayNU(pSoapArray: any): Array<TaxSchemeDescription>;
    static FromSoapNU(this: void, pSoapData: any): TaxSchemeDescription;
}
export declare class TMColumnDef {
    displayName: string;
    columnId: TMColumnId;
    static FromSoapArrayNU(pSoapArray: any): Array<TMColumnDef>;
    static FromSoapNU(this: void, pSoapData: any): TMColumnDef;
}
export declare class TMRow {
    texts: Array<TMText>;
    textId: string;
    readOnly: boolean;
    visible: boolean;
    static FromSoapArrayNU(pSoapArray: any): Array<TMRow>;
    static FromSoapArray(pSoapArray: any): Array<TMRow> | undefined;
    static FromSoapNU(this: void, pSoapData: any): TMRow;
}
export declare class TMRowDef {
    displayName: string;
    type: TMTextType;
    textId: string;
    readOnly: boolean;
    defaultVisible: boolean;
    static FromSoapArrayNU(pSoapArray: any): Array<TMRowDef>;
    static FromSoapNU(this: void, pSoapData: any): TMRowDef;
}
export declare class TMTable {
    columns: Array<TMColumnDef>;
    rows: Array<TMRowDef>;
    static FromSoap(pSoapData: any): TMTable | undefined;
}
export declare class TMText {
    text: string;
    language?: string;
    static FromSoapArrayNU(pSoapArray: any): Array<TMText>;
    static FromSoapNU(this: void, pSoapData: any): TMText;
}
export declare class UpdateBasketArticleResult {
    itemId: string;
    updateState: OFMLUpdateState;
    static FromSoapArrayNU(pSoapArray: any): Array<UpdateBasketArticleResult>;
    static FromSoapNU(this: void, pSoapData: any): UpdateBasketArticleResult;
}
