/* eslint-disable @typescript-eslint/no-unsafe-return */
/* eslint-disable @typescript-eslint/no-unsafe-member-access */
/* eslint-disable @typescript-eslint/no-unsafe-call */
/* eslint-disable @typescript-eslint/no-unsafe-assignment */
import { __decorate } from "tslib";
import { ERR_INVALID_ARGUMENT } from "../../utils/error";
import { Log } from "../../utils/Log";
import { soapAttribute, SoapRequestData, SoapService, soapNodeText } from "../SoapService";
export class AddStateCode extends SoapRequestData {
    constructor() {
        super();
        this.value = "";
        this.domain = "";
    }
    static FromSoapArray(pSoapArray) {
        return (SoapService.SoapDataToArray(pSoapArray, AddStateCode.FromSoapNU));
    }
    static FromSoapNU(pSoapData) {
        var _a;
        if (pSoapData == null)
            throw new Error(ERR_INVALID_ARGUMENT);
        const tCode = new AddStateCode();
        tCode.value = (_a = SoapService.GetSoapDataNodeValue(pSoapData)) !== null && _a !== void 0 ? _a : "";
        tCode.domain = pSoapData.domain;
        return (tCode);
    }
}
__decorate([
    soapNodeText()
], AddStateCode.prototype, "value", void 0);
__decorate([
    soapAttribute()
], AddStateCode.prototype, "domain", void 0);
export class ArticleClassification extends SoapRequestData {
    constructor() {
        super();
        this.system = "";
        this.classId = "";
    }
    /** @internal */
    _getPropertyValue(pProperty) {
        //handle extra description array wrapper
        if (pProperty === "description")
            return (this.description != null ? { text: this.description } : undefined);
        return (super._getPropertyValue(pProperty));
    }
    static FromSoapArray(pSoapArray) {
        return (SoapService.SoapDataToArray(pSoapArray, ArticleClassification.FromSoapNU));
    }
    static FromSoapNU(pSoapData) {
        var _a;
        if (pSoapData == null)
            throw new Error(ERR_INVALID_ARGUMENT);
        const tArtClass = new ArticleClassification();
        tArtClass.system = pSoapData.system;
        tArtClass.qualifier = pSoapData.qualifier;
        tArtClass.classId = pSoapData.classId;
        //handle extra array wrappers
        tArtClass.description = DisplayText.FromSoapArray((_a = pSoapData.description) === null || _a === void 0 ? void 0 : _a.text);
        return (tArtClass);
    }
}
__decorate([
    soapAttribute()
], ArticleClassification.prototype, "system", void 0);
__decorate([
    soapAttribute()
], ArticleClassification.prototype, "qualifier", void 0);
__decorate([
    soapAttribute()
], ArticleClassification.prototype, "classId", void 0);
export class ArticleDescription extends SoapRequestData {
    /** @internal */
    _getPropertyValue(pProperty) {
        //handle extra shortText array wrapper
        if (pProperty === "shortText")
            return (this.shortText != null ? { text: this.shortText } : undefined);
        //handle extra longText array wrapper
        if (pProperty === "longText")
            return (this.longText != null ? { text: this.longText } : undefined);
        //handle extra featureText array wrapper
        if (pProperty === "featureText")
            return (this.featureText != null ? { text: this.featureText } : undefined);
        return (super._getPropertyValue(pProperty));
    }
    static FromSoap(pSoapData) {
        var _a, _b, _c;
        if (pSoapData == null)
            return (undefined);
        const tArtDesc = new ArticleDescription();
        //handle extra array wrappers
        tArtDesc.shortText = DisplayText.FromSoapArray((_a = pSoapData.shortText) === null || _a === void 0 ? void 0 : _a.text);
        tArtDesc.longText = DisplayText.FromSoapArray((_b = pSoapData.longText) === null || _b === void 0 ? void 0 : _b.text);
        tArtDesc.featureText = DisplayText.FromSoapArray((_c = pSoapData.featureText) === null || _c === void 0 ? void 0 : _c.text);
        return (tArtDesc);
    }
}
export class ArticleProperties extends SoapRequestData {
    /** @internal */
    _getPropertyValue(pProperty) {
        //handle extra articleClassifications array wrapper
        if (pProperty === "articleClassifications")
            return (this.articleClassifications != null ? { articleClassification: this.articleClassifications } : undefined);
        return (super._getPropertyValue(pProperty));
    }
    static FromSoapArray(pSoapArray) {
        return (SoapService.SoapDataToArray(pSoapArray, ArticleProperties.FromSoapNU));
    }
    static FromSoap(pSoapData) {
        var _a;
        if (pSoapData == null)
            return (undefined);
        const tArticleProps = new ArticleProperties();
        tArticleProps.catalogId = pSoapData.catalogId;
        tArticleProps.manufacturerId = pSoapData.manufacturerId;
        tArticleProps.manufacturerName = pSoapData.manufacturerName;
        tArticleProps.seriesId = pSoapData.seriesId;
        tArticleProps.seriesName = pSoapData.seriesName;
        tArticleProps.manufacturer = pSoapData.manufacturer;
        tArticleProps.program = pSoapData.program;
        tArticleProps.distributionRegion = pSoapData.distributionRegion;
        tArticleProps.baseArticleNumber = pSoapData.baseArticleNumber;
        tArticleProps.finalArticleNumber = pSoapData.finalArticleNumber;
        tArticleProps.variantCode = pSoapData.variantCode;
        tArticleProps.ofmlVariantCode = pSoapData.ofmlVariantCode;
        tArticleProps.useFinalArticleNumber = SoapService.SoapDataToBool(pSoapData.useFinalArticleNumber);
        tArticleProps.shortText = pSoapData.shortText;
        tArticleProps.longText = pSoapData.longText;
        tArticleProps.featureText = pSoapData.featureText;
        tArticleProps.descriptionMode = pSoapData.descriptionMode;
        tArticleProps.productDescription = ArticleDescription.FromSoap(pSoapData.productDescription);
        tArticleProps.userDescription = ArticleDescription.FromSoap(pSoapData.userDescription);
        tArticleProps.currency = pSoapData.currency;
        tArticleProps.purchaseCurrency = pSoapData.purchaseCurrency;
        tArticleProps.salesCurrency = pSoapData.salesCurrency;
        tArticleProps.purchasePrice = SoapService.SoapDataToDecimal(pSoapData.purchasePrice);
        tArticleProps.salesPrice = SoapService.SoapDataToDecimal(pSoapData.salesPrice);
        tArticleProps.priceDateSupported = SoapService.SoapDataToBool(pSoapData.priceDateSupported);
        tArticleProps.priceDateEditable = SoapService.SoapDataToBool(pSoapData.priceDateEditable);
        tArticleProps.priceDate = pSoapData.priceDate;
        tArticleProps.quantity = SoapService.SoapDataToDecimal(pSoapData.quantity);
        tArticleProps.alternativePosition = SoapService.SoapDataToBool(pSoapData.alternativePosition);
        tArticleProps.excludedCalculations = SoapService.SoapDataToArray(pSoapData.excludedCalculations);
        tArticleProps.inactivePositionState = InactivePositionState.FromSoapArray(pSoapData.inactivePositionState);
        tArticleProps.inconsistencyFlag = SoapService.SoapDataToBool(pSoapData.inconsistencyFlag);
        tArticleProps.inconsistencyReason = SoapService.SoapDataToArray(pSoapData.inconsistencyReason);
        tArticleProps.priceInfo = PriceInfo.FromSoap(pSoapData.priceInfo);
        tArticleProps.packagingInfo = PackagingInfo.FromSoap(pSoapData.packagingInfo);
        tArticleProps.pseudoArticle = SoapService.SoapDataToBool(pSoapData.pseudoArticle);
        tArticleProps.nonOfferArticle = SoapService.SoapDataToBool(pSoapData.nonOfferArticle);
        tArticleProps.nonOrderArticle = SoapService.SoapDataToBool(pSoapData.nonOrderArticle);
        tArticleProps.ofmlUpdateState = pSoapData.ofmlUpdateState;
        tArticleProps.geometryId = pSoapData.geometryId;
        tArticleProps.subArticles = ArticleProperties.FromSoapArray(pSoapData.subArticles);
        tArticleProps.addStateCodes = AddStateCode.FromSoapArray(pSoapData.addStateCodes);
        //handle extra array wrappers
        tArticleProps.articleClassifications = ArticleClassification.FromSoapArray((_a = pSoapData.articleClassifications) === null || _a === void 0 ? void 0 : _a.articleClassification);
        return (tArticleProps);
    }
    static FromSoapNU(pSoapData) {
        if (pSoapData == null)
            throw new Error(ERR_INVALID_ARGUMENT);
        return (ArticleProperties.FromSoap(pSoapData));
    }
}
export class BasketColumn extends SoapRequestData {
    constructor() {
        super();
        this.id = "";
    }
    static FromSoapArrayNU(pSoapArray) {
        return (SoapService.SoapDataToArrayNU(pSoapArray, BasketColumn.FromSoapNU));
    }
    static FromSoap(pSoapData) {
        if (pSoapData == null)
            return (undefined);
        const tColumn = new BasketColumn();
        tColumn.name = pSoapData.name;
        tColumn.title = pSoapData.title;
        tColumn.defaultValue = pSoapData.defaultValue;
        tColumn.id = pSoapData.id;
        tColumn.type = pSoapData.type;
        tColumn.itemAttrId = pSoapData.itemAttrId;
        tColumn.removable = SoapService.SoapDataToBool(pSoapData.removable);
        tColumn.editable = SoapService.SoapDataToBool(pSoapData.editable);
        tColumn.defaultColumn = pSoapData.defaultColumn;
        tColumn.minWidth = SoapService.SoapDataToFloat(pSoapData.minWidth);
        tColumn.weight = SoapService.SoapDataToInt(pSoapData.weight);
        tColumn.readOnly = SoapService.SoapDataToBool(pSoapData.readOnly);
        return (tColumn);
    }
    static FromSoapNU(pSoapData) {
        if (pSoapData == null)
            throw new Error(ERR_INVALID_ARGUMENT);
        return (BasketColumn.FromSoap(pSoapData));
    }
}
__decorate([
    soapAttribute()
], BasketColumn.prototype, "id", void 0);
__decorate([
    soapAttribute()
], BasketColumn.prototype, "type", void 0);
__decorate([
    soapAttribute()
], BasketColumn.prototype, "itemAttrId", void 0);
__decorate([
    soapAttribute()
], BasketColumn.prototype, "removable", void 0);
__decorate([
    soapAttribute()
], BasketColumn.prototype, "editable", void 0);
__decorate([
    soapAttribute()
], BasketColumn.prototype, "defaultColumn", void 0);
__decorate([
    soapAttribute()
], BasketColumn.prototype, "minWidth", void 0);
__decorate([
    soapAttribute()
], BasketColumn.prototype, "weight", void 0);
__decorate([
    soapAttribute()
], BasketColumn.prototype, "readOnly", void 0);
export class BasketConfig extends SoapRequestData {
    static FromSoap(pSoapData) {
        if (pSoapData == null)
            return (undefined);
        const tConfig = new BasketConfig();
        tConfig.viewIds = SoapService.SoapDataToArray(pSoapData.viewIds);
        tConfig.columnIds = SoapService.SoapDataToArray(pSoapData.columnIds);
        tConfig.obkVersionInfo = OBKVersionInfo.FromSoap(pSoapData.obkVersionInfo);
        tConfig.defaultView = pSoapData.defaultView;
        tConfig.columnsEditable = SoapService.SoapDataToBool(pSoapData.columnsEditable);
        tConfig.currency = pSoapData.currency;
        tConfig.currencyEditable = SoapService.SoapDataToBool(pSoapData.currencyEditable);
        tConfig.defaultPriceDate = pSoapData.defaultPriceDate;
        return (tConfig);
    }
}
__decorate([
    soapAttribute()
], BasketConfig.prototype, "defaultView", void 0);
__decorate([
    soapAttribute()
], BasketConfig.prototype, "columnsEditable", void 0);
__decorate([
    soapAttribute()
], BasketConfig.prototype, "currency", void 0);
__decorate([
    soapAttribute()
], BasketConfig.prototype, "currencyEditable", void 0);
__decorate([
    soapAttribute()
], BasketConfig.prototype, "defaultPriceDate", void 0);
export class BasketViewConfig extends SoapRequestData {
    constructor() {
        super();
        this.viewId = "";
    }
    static FromSoapArrayNU(pSoapArray) {
        return (SoapService.SoapDataToArrayNU(pSoapArray, BasketViewConfig.FromSoapNU));
    }
    static FromSoap(pSoapData) {
        if (pSoapData == null)
            return (undefined);
        const tConfig = new BasketViewConfig();
        tConfig.name = pSoapData.name;
        tConfig.visibleColumns = SoapService.SoapDataToArray(pSoapData.visibleColumns);
        tConfig.columnWidths = ColumnWidth.FromSoapArray(pSoapData.columnWidths);
        tConfig.sortConfig = BasketViewSortConfig.FromSoap(pSoapData.sortConfig);
        tConfig.articleDescrMode = SoapService.SoapDataToArray(pSoapData.articleDescrMode);
        tConfig.viewId = pSoapData.viewId;
        tConfig.removable = SoapService.SoapDataToBool(pSoapData.removable);
        tConfig.editable = SoapService.SoapDataToBool(pSoapData.editable);
        tConfig.displayMode = pSoapData.displayMode;
        tConfig.expandGroups = SoapService.SoapDataToBool(pSoapData.expandGroups);
        tConfig.expandPlanningFolders = SoapService.SoapDataToBool(pSoapData.expandPlanningFolders);
        tConfig.expandBasketFolders = SoapService.SoapDataToBool(pSoapData.expandBasketFolders);
        tConfig.expandPartialPlannings = SoapService.SoapDataToBool(pSoapData.expandPartialPlannings);
        tConfig.expandAggregates = SoapService.SoapDataToBool(pSoapData.expandAggregates);
        tConfig.textItemsVisible = SoapService.SoapDataToBool(pSoapData.textItemsVisible);
        tConfig.mergeMode = pSoapData.mergeMode;
        tConfig.autoColumnWidth = SoapService.SoapDataToBool(pSoapData.autoColumnWidth);
        tConfig.hiddenDiscounts = SoapService.SoapDataToBool(pSoapData.hiddenDiscounts);
        tConfig.setArticleMode = pSoapData.setArticleMode;
        return (tConfig);
    }
    static FromSoapNU(pSoapData) {
        if (pSoapData == null)
            throw new Error(ERR_INVALID_ARGUMENT);
        return (BasketViewConfig.FromSoap(pSoapData));
    }
}
__decorate([
    soapAttribute()
], BasketViewConfig.prototype, "viewId", void 0);
__decorate([
    soapAttribute()
], BasketViewConfig.prototype, "removable", void 0);
__decorate([
    soapAttribute()
], BasketViewConfig.prototype, "editable", void 0);
__decorate([
    soapAttribute()
], BasketViewConfig.prototype, "displayMode", void 0);
__decorate([
    soapAttribute()
], BasketViewConfig.prototype, "expandGroups", void 0);
__decorate([
    soapAttribute()
], BasketViewConfig.prototype, "expandPlanningFolders", void 0);
__decorate([
    soapAttribute()
], BasketViewConfig.prototype, "expandBasketFolders", void 0);
__decorate([
    soapAttribute()
], BasketViewConfig.prototype, "expandPartialPlannings", void 0);
__decorate([
    soapAttribute()
], BasketViewConfig.prototype, "expandAggregates", void 0);
__decorate([
    soapAttribute()
], BasketViewConfig.prototype, "textItemsVisible", void 0);
__decorate([
    soapAttribute()
], BasketViewConfig.prototype, "nonOfferArticlesVisible", void 0);
__decorate([
    soapAttribute()
], BasketViewConfig.prototype, "nonOrderArticlesVisible", void 0);
__decorate([
    soapAttribute()
], BasketViewConfig.prototype, "mergeMode", void 0);
__decorate([
    soapAttribute()
], BasketViewConfig.prototype, "autoColumnWidth", void 0);
__decorate([
    soapAttribute()
], BasketViewConfig.prototype, "hiddenDiscounts", void 0);
__decorate([
    soapAttribute()
], BasketViewConfig.prototype, "setArticleMode", void 0);
export class BasketViewSortConfig extends SoapRequestData {
    /** @internal */
    _getPropertyValue(pProperty) {
        //handle extra groups array wrapper
        if (pProperty === "groups")
            return (this.groups != null ? { group: this.groups } : undefined);
        return (super._getPropertyValue(pProperty));
    }
    static FromSoap(pSoapData) {
        var _a;
        if (pSoapData == null)
            return (undefined);
        const tConfig = new BasketViewSortConfig();
        tConfig.collatorStrength = pSoapData.collatorStrength;
        tConfig.collatorDecomposition = pSoapData.collatorDecomposition;
        //handle extra groups array wrapper
        tConfig.groups = SortGroup.FromSoapArray((_a = pSoapData.groups) === null || _a === void 0 ? void 0 : _a.group);
        return (tConfig);
    }
}
__decorate([
    soapAttribute()
], BasketViewSortConfig.prototype, "collatorStrength", void 0);
__decorate([
    soapAttribute()
], BasketViewSortConfig.prototype, "collatorDecomposition", void 0);
export class ColumnSortOrder extends SoapRequestData {
    constructor() {
        super();
        this.columnId = "";
    }
    static FromSoapArray(pSoapArray) {
        return (SoapService.SoapDataToArray(pSoapArray, ColumnSortOrder.FromSoapNU));
    }
    static FromSoapNU(pSoapData) {
        if (pSoapData == null)
            throw new Error(ERR_INVALID_ARGUMENT);
        const tOrder = new ColumnSortOrder();
        tOrder.columnId = pSoapData.columnId;
        tOrder.ascending = SoapService.SoapDataToBool(pSoapData.ascending);
        tOrder.undefinedFirst = SoapService.SoapDataToBool(pSoapData.undefinedFirst);
        return (tOrder);
    }
}
__decorate([
    soapAttribute()
], ColumnSortOrder.prototype, "columnId", void 0);
__decorate([
    soapAttribute()
], ColumnSortOrder.prototype, "ascending", void 0);
__decorate([
    soapAttribute()
], ColumnSortOrder.prototype, "undefinedFirst", void 0);
export class ColumnWidth extends SoapRequestData {
    constructor() {
        super();
        this.columnId = "";
        this.width = 0;
    }
    static FromSoapArray(pSoapArray) {
        return (SoapService.SoapDataToArray(pSoapArray, ColumnWidth.FromSoapNU));
    }
    static FromSoapNU(pSoapData) {
        if (pSoapData == null)
            throw new Error(ERR_INVALID_ARGUMENT);
        const tWidth = new ColumnWidth();
        tWidth.columnId = pSoapData.columnId;
        tWidth.width = SoapService.SoapDataToInt(pSoapData.value);
        return (tWidth);
    }
}
__decorate([
    soapAttribute()
], ColumnWidth.prototype, "columnId", void 0);
__decorate([
    soapAttribute()
], ColumnWidth.prototype, "width", void 0);
export class ComposableGeometryProperties extends SoapRequestData {
    static FromSoapArray(pSoapArray) {
        return (SoapService.SoapDataToArray(pSoapArray, ComposableGeometryProperties.FromSoapNU));
    }
    static FromSoap(pSoapData) {
        if (pSoapData == null)
            return (undefined);
        const tGeomProps = new ComposableGeometryProperties();
        tGeomProps.enabled = SoapService.SoapDataToBool(pSoapData.enabled);
        tGeomProps.position = Vector3.FromSoap(pSoapData.position);
        tGeomProps.rotation = Rotation.FromSoap(pSoapData.rotation);
        tGeomProps.scale = Vector3.FromSoap(pSoapData.scale);
        tGeomProps.geometry = pSoapData.geometry;
        tGeomProps.itemId = pSoapData.itemId;
        return (tGeomProps);
    }
    static FromSoapNU(pSoapData) {
        if (pSoapData == null)
            throw new Error(ERR_INVALID_ARGUMENT);
        return (ComposableGeometryProperties.FromSoap(pSoapData));
    }
}
__decorate([
    soapAttribute()
], ComposableGeometryProperties.prototype, "itemId", void 0);
export class CopyOptions extends SoapRequestData {
}
__decorate([
    soapAttribute()
], CopyOptions.prototype, "encoding", void 0);
__decorate([
    soapAttribute()
], CopyOptions.prototype, "suffix", void 0);
__decorate([
    soapAttribute()
], CopyOptions.prototype, "overwrite", void 0);
__decorate([
    soapAttribute()
], CopyOptions.prototype, "cut", void 0);
__decorate([
    soapAttribute()
], CopyOptions.prototype, "omitPriceData", void 0);
export class DisplayText extends SoapRequestData {
    constructor() {
        super();
        this.value = "";
    }
    static FromSoapArray(pSoapArray) {
        return (SoapService.SoapDataToArray(pSoapArray, DisplayText.FromSoapNU));
    }
    static FromSoapNU(pSoapData) {
        var _a;
        if (pSoapData == null)
            throw new Error(ERR_INVALID_ARGUMENT);
        const tName = new DisplayText();
        tName.value = (_a = SoapService.GetSoapDataNodeValue(pSoapData)) !== null && _a !== void 0 ? _a : "";
        tName.lang = pSoapData.lang;
        return (tName);
    }
}
__decorate([
    soapNodeText()
], DisplayText.prototype, "value", void 0);
__decorate([
    soapAttribute()
], DisplayText.prototype, "lang", void 0);
export class ExchangeRate extends SoapRequestData {
    constructor() {
        super();
        this.currency = "";
        this.rate = 0;
    }
    static FromSoapArrayNU(pSoapArray) {
        return (SoapService.SoapDataToArrayNU(pSoapArray, ExchangeRate.FromSoapNU));
    }
    static FromSoapNU(pSoapData) {
        if (pSoapData == null)
            throw new Error(ERR_INVALID_ARGUMENT);
        const tRate = new ExchangeRate();
        tRate.currency = pSoapData.currency;
        tRate.rate = SoapService.SoapDataToDecimal(pSoapData.rate);
        return (tRate);
    }
}
__decorate([
    soapAttribute()
], ExchangeRate.prototype, "currency", void 0);
__decorate([
    soapAttribute()
], ExchangeRate.prototype, "rate", void 0);
export class FolderProperties extends SoapRequestData {
    /** @internal */
    _getPropertyValue(pProperty) {
        //handle extra displayName array wrapper
        if (pProperty === "displayName")
            return (this.displayName != null ? { text: this.displayName } : undefined);
        //handle extra longDisplayText array wrapper
        if (pProperty === "longDisplayText")
            return (this.longDisplayText != null ? { text: this.longDisplayText } : undefined);
        return (super._getPropertyValue(pProperty));
    }
    static FromSoap(pSoapData) {
        var _a, _b;
        if (pSoapData == null)
            return (undefined);
        const tFolderProps = new FolderProperties();
        tFolderProps.name = pSoapData.name;
        tFolderProps.showSubTotal = SoapService.SoapDataToBool(pSoapData.showSubTotal);
        //handle extra displayName array wrapper
        tFolderProps.displayName = DisplayText.FromSoapArray((_a = pSoapData.displayName) === null || _a === void 0 ? void 0 : _a.text);
        //handle extra longDisplayText array wrapper
        tFolderProps.longDisplayText = DisplayText.FromSoapArray((_b = pSoapData.longDisplayText) === null || _b === void 0 ? void 0 : _b.text);
        return (tFolderProps);
    }
}
export class GetArticleDataOptions extends SoapRequestData {
}
__decorate([
    soapAttribute()
], GetArticleDataOptions.prototype, "separateCurrencies", void 0);
__decorate([
    soapAttribute()
], GetArticleDataOptions.prototype, "highResPropValueIcons", void 0);
__decorate([
    soapAttribute()
], GetArticleDataOptions.prototype, "fetchPropValueImages", void 0);
export class GetArticleFeaturesOptions extends SoapRequestData {
}
export class GetChoiceListOptions extends SoapRequestData {
}
__decorate([
    soapAttribute()
], GetChoiceListOptions.prototype, "convertSurcharge", void 0);
__decorate([
    soapAttribute()
], GetChoiceListOptions.prototype, "formatSurcharge", void 0);
__decorate([
    soapAttribute()
], GetChoiceListOptions.prototype, "discardSurcharge", void 0);
__decorate([
    soapAttribute()
], GetChoiceListOptions.prototype, "highResPropValueIcons", void 0);
__decorate([
    soapAttribute()
], GetChoiceListOptions.prototype, "fetchPropValueImages", void 0);
export class InactivePositionState extends SoapRequestData {
    constructor() {
        super();
        this.ppName = "";
    }
    static FromSoapArray(pSoapArray) {
        return (SoapService.SoapDataToArray(pSoapArray, InactivePositionState.FromSoapNU));
    }
    static FromSoapNU(pSoapData) {
        if (pSoapData == null)
            throw new Error(ERR_INVALID_ARGUMENT);
        const tState = new InactivePositionState();
        tState.ppName = pSoapData.ppName;
        tState.optional = SoapService.SoapDataToBool(pSoapData.optional);
        return (tState);
    }
}
__decorate([
    soapAttribute()
], InactivePositionState.prototype, "ppName", void 0);
__decorate([
    soapAttribute()
], InactivePositionState.prototype, "optional", void 0);
export class InsertArticleOptions extends SoapRequestData {
}
export class InsertInfo extends SoapRequestData {
    constructor() {
        super();
        this.baseArticleNumber = "";
    }
}
export class ItemProperties extends SoapRequestData {
    static FromSoapArrayNU(pSoapArray) {
        return (SoapService.SoapDataToArrayNU(pSoapArray, ItemProperties.FromSoapNU));
    }
    static FromSoapNU(pSoapData) {
        if (pSoapData == null)
            throw new Error(ERR_INVALID_ARGUMENT);
        const tItemProps = new ItemProperties();
        tItemProps.itemId = pSoapData.itemId;
        tItemProps.itemType = pSoapData.itemType;
        tItemProps.visible = SoapService.SoapDataToBool(pSoapData.visible);
        tItemProps.expanded = SoapService.SoapDataToBool(pSoapData.expanded);
        tItemProps.label = pSoapData.label;
        tItemProps.setArticleId = pSoapData.setArticleId;
        tItemProps.tmRows = TMRow.FromSoapArray(pSoapData.tmRows);
        tItemProps.tmDescription = pSoapData.tmDescription;
        tItemProps.composableGeometry = ComposableGeometryProperties.FromSoap(pSoapData.composableGeometry);
        tItemProps.composableGeometries = ComposableGeometryProperties.FromSoapArray(pSoapData.composableGeometries);
        tItemProps.folder = FolderProperties.FromSoap(pSoapData.folder);
        tItemProps.article = ArticleProperties.FromSoap(pSoapData.article);
        tItemProps.setArticle = SetArticleProperties.FromSoap(pSoapData.setArticle);
        tItemProps.textItem = TextItemProperties.FromSoap(pSoapData.textItem);
        tItemProps.positionNumber = pSoapData.positionNumber;
        return (tItemProps);
    }
}
__decorate([
    soapAttribute()
], ItemProperties.prototype, "positionNumber", void 0);
export class ItemSelectionOptions extends SoapRequestData {
}
__decorate([
    soapAttribute()
], ItemSelectionOptions.prototype, "wholeComposite", void 0);
__decorate([
    soapAttribute()
], ItemSelectionOptions.prototype, "subItems", void 0);
__decorate([
    soapAttribute()
], ItemSelectionOptions.prototype, "parentItems", void 0);
__decorate([
    soapAttribute()
], ItemSelectionOptions.prototype, "viewId", void 0);
export class DeleteItemsOptions extends ItemSelectionOptions {
}
__decorate([
    soapAttribute()
], DeleteItemsOptions.prototype, "subArticles", void 0);
export class GetAllItemsOptions extends ItemSelectionOptions {
}
__decorate([
    soapAttribute()
], GetAllItemsOptions.prototype, "setArticleIds", void 0);
__decorate([
    soapAttribute()
], GetAllItemsOptions.prototype, "geometryIds", void 0);
__decorate([
    soapAttribute()
], GetAllItemsOptions.prototype, "positionNumbers", void 0);
__decorate([
    soapAttribute()
], GetAllItemsOptions.prototype, "basketItems", void 0);
export class GetImagesOptions extends ItemSelectionOptions {
}
__decorate([
    soapAttribute()
], GetImagesOptions.prototype, "useCache", void 0);
__decorate([
    soapAttribute()
], GetImagesOptions.prototype, "generate", void 0);
__decorate([
    soapAttribute()
], GetImagesOptions.prototype, "itemIds", void 0);
__decorate([
    soapAttribute()
], GetImagesOptions.prototype, "attributes", void 0);
export class GetItemFieldsOptions extends ItemSelectionOptions {
}
__decorate([
    soapAttribute()
], GetItemFieldsOptions.prototype, "useDefault", void 0);
__decorate([
    soapAttribute()
], GetItemFieldsOptions.prototype, "expandVariables", void 0);
__decorate([
    soapAttribute()
], GetItemFieldsOptions.prototype, "resolveURI", void 0);
__decorate([
    soapAttribute()
], GetItemFieldsOptions.prototype, "useImageCache", void 0);
__decorate([
    soapAttribute()
], GetItemFieldsOptions.prototype, "generateImages", void 0);
export class GetItemPropertiesOptions extends ItemSelectionOptions {
}
__decorate([
    soapAttribute()
], GetItemPropertiesOptions.prototype, "priceInfo", void 0);
__decorate([
    soapAttribute()
], GetItemPropertiesOptions.prototype, "pricingProcedureName", void 0);
__decorate([
    soapAttribute()
], GetItemPropertiesOptions.prototype, "positionNumbers", void 0);
__decorate([
    soapAttribute()
], GetItemPropertiesOptions.prototype, "addStateCodes", void 0);
__decorate([
    soapAttribute()
], GetItemPropertiesOptions.prototype, "textMode", void 0);
__decorate([
    soapAttribute()
], GetItemPropertiesOptions.prototype, "preferUserDescriptions", void 0);
__decorate([
    soapAttribute()
], GetItemPropertiesOptions.prototype, "separateCurrencies", void 0);
__decorate([
    soapAttribute()
], GetItemPropertiesOptions.prototype, "inactivePositionState", void 0);
__decorate([
    soapAttribute()
], GetItemPropertiesOptions.prototype, "articleClassifications", void 0);
__decorate([
    soapAttribute()
], GetItemPropertiesOptions.prototype, "includeCalculationErrorsInInconsistencies", void 0);
export class GetManufacturerInfoOptions extends ItemSelectionOptions {
}
__decorate([
    soapAttribute()
], GetManufacturerInfoOptions.prototype, "allData", void 0);
__decorate([
    soapAttribute()
], GetManufacturerInfoOptions.prototype, "allLanguages", void 0);
__decorate([
    soapAttribute()
], GetManufacturerInfoOptions.prototype, "manufacturerName", void 0);
__decorate([
    soapAttribute()
], GetManufacturerInfoOptions.prototype, "seriesInfo", void 0);
__decorate([
    soapAttribute()
], GetManufacturerInfoOptions.prototype, "seriesName", void 0);
__decorate([
    soapAttribute()
], GetManufacturerInfoOptions.prototype, "manufacturerConfig", void 0);
__decorate([
    soapAttribute()
], GetManufacturerInfoOptions.prototype, "distributorName", void 0);
__decorate([
    soapAttribute()
], GetManufacturerInfoOptions.prototype, "copyright", void 0);
__decorate([
    soapAttribute()
], GetManufacturerInfoOptions.prototype, "address", void 0);
__decorate([
    soapAttribute()
], GetManufacturerInfoOptions.prototype, "externalCatalog", void 0);
export class CondGroupSelectionOptions extends ItemSelectionOptions {
}
__decorate([
    soapAttribute()
], CondGroupSelectionOptions.prototype, "excludeInactiveItems", void 0);
__decorate([
    soapAttribute()
], CondGroupSelectionOptions.prototype, "includeInactiveItems", void 0);
export class GetPriceCalculationSheetOptions extends CondGroupSelectionOptions {
}
__decorate([
    soapAttribute()
], GetPriceCalculationSheetOptions.prototype, "sumUpComposite", void 0);
__decorate([
    soapAttribute()
], GetPriceCalculationSheetOptions.prototype, "itemCondAmountPerUnit", void 0);
__decorate([
    soapAttribute()
], GetPriceCalculationSheetOptions.prototype, "headerCondAmountPerUnit", void 0);
export class ItemField extends SoapRequestData {
    constructor() {
        super();
        this.data = "";
        this.itemId = "";
        this.columnId = "";
    }
    static FromSoapArrayNU(pSoapArray) {
        return (SoapService.SoapDataToArrayNU(pSoapArray, ItemField.FromSoapNU));
    }
    static FromSoapNU(pSoapData) {
        if (pSoapData == null)
            throw new Error(ERR_INVALID_ARGUMENT);
        const tField = new ItemField();
        tField.data = pSoapData.data;
        tField.itemId = pSoapData.itemId;
        tField.columnId = pSoapData.columnId;
        return (tField);
    }
}
__decorate([
    soapAttribute()
], ItemField.prototype, "itemId", void 0);
__decorate([
    soapAttribute()
], ItemField.prototype, "columnId", void 0);
export class UpdateBasketArticlesOptions extends ItemSelectionOptions {
}
__decorate([
    soapAttribute()
], UpdateBasketArticlesOptions.prototype, "update", void 0);
__decorate([
    soapAttribute()
], UpdateBasketArticlesOptions.prototype, "migrate", void 0);
__decorate([
    soapAttribute()
], UpdateBasketArticlesOptions.prototype, "recalculate", void 0);
__decorate([
    soapAttribute()
], UpdateBasketArticlesOptions.prototype, "priceDate", void 0);
export class OAPActionContext extends SoapRequestData {
    constructor() {
        super();
        this.self = "";
    }
}
__decorate([
    soapAttribute()
], OAPActionContext.prototype, "self", void 0);
__decorate([
    soapAttribute()
], OAPActionContext.prototype, "interactor", void 0);
__decorate([
    soapAttribute()
], OAPActionContext.prototype, "dpr", void 0);
export class OBKVersionInfo extends SoapRequestData {
    constructor() {
        super();
        this.vendorKey = "";
        this.appKey = "";
        this.appVersion = "";
        this.bskXmlVersion = "";
    }
    static FromSoap(pSoapData) {
        if (pSoapData == null)
            return (undefined);
        const tInfo = new OBKVersionInfo();
        tInfo.vendorKey = pSoapData.vendorKey;
        tInfo.appKey = pSoapData.appKey;
        tInfo.appVersion = pSoapData.appVersion;
        tInfo.bskXmlVersion = pSoapData.bskXmlVersion;
        tInfo.bskVersion = pSoapData.bskVersion;
        return (tInfo);
    }
}
__decorate([
    soapAttribute()
], OBKVersionInfo.prototype, "vendorKey", void 0);
__decorate([
    soapAttribute()
], OBKVersionInfo.prototype, "appKey", void 0);
__decorate([
    soapAttribute()
], OBKVersionInfo.prototype, "appVersion", void 0);
__decorate([
    soapAttribute()
], OBKVersionInfo.prototype, "bskXmlVersion", void 0);
__decorate([
    soapAttribute()
], OBKVersionInfo.prototype, "bskVersion", void 0);
export class OperationMode extends SoapRequestData {
}
__decorate([
    soapAttribute()
], OperationMode.prototype, "subPositions", void 0);
__decorate([
    soapAttribute()
], OperationMode.prototype, "mainArticles", void 0);
__decorate([
    soapAttribute()
], OperationMode.prototype, "breakUpSetArticles", void 0);
__decorate([
    soapAttribute()
], OperationMode.prototype, "migrate", void 0);
export class PackagingInfo extends SoapRequestData {
    static FromSoap(pSoapData) {
        if (pSoapData == null)
            return (undefined);
        const tPackInfo = new PackagingInfo();
        tPackInfo.width = Quantity.FromSoap(pSoapData.width);
        tPackInfo.height = Quantity.FromSoap(pSoapData.height);
        tPackInfo.depth = Quantity.FromSoap(pSoapData.depth);
        tPackInfo.volume = Quantity.FromSoap(pSoapData.volume);
        tPackInfo.tareWeight = Quantity.FromSoap(pSoapData.tareWeight);
        tPackInfo.netWeight = Quantity.FromSoap(pSoapData.netWeight);
        tPackInfo.itemsPerPackUnit = SoapService.SoapDataToInt(pSoapData.itemsPerPackUnit);
        tPackInfo.packUnitsPerArticle = SoapService.SoapDataToInt(pSoapData.packUnitsPerArticle);
        return (tPackInfo);
    }
}
export class RelocateItemsOptions extends SoapRequestData {
}
__decorate([
    soapAttribute()
], RelocateItemsOptions.prototype, "doNotModify", void 0);
__decorate([
    soapAttribute()
], RelocateItemsOptions.prototype, "flat", void 0);
export class PasteOptions extends SoapRequestData {
}
__decorate([
    soapAttribute()
], PasteOptions.prototype, "reuseItemIds", void 0);
__decorate([
    soapAttribute()
], PasteOptions.prototype, "returnOriginalItemIds", void 0);
__decorate([
    soapAttribute()
], PasteOptions.prototype, "ignoreComposableGeometries", void 0);
export class PasteContainerOptions extends PasteOptions {
}
__decorate([
    soapAttribute()
], PasteContainerOptions.prototype, "setArticleIds", void 0);
__decorate([
    soapAttribute()
], PasteContainerOptions.prototype, "geometryIds", void 0);
export class Rotation extends SoapRequestData {
    constructor() {
        super();
        this.angle = 0;
    }
    static FromSoap(pSoapData) {
        if (pSoapData == null)
            return (undefined);
        const tRot = new Rotation();
        tRot.axis = Vector3.FromSoapNU(pSoapData.axis);
        tRot.angle = SoapService.SoapDataToFloat(pSoapData.angle);
        return (tRot);
    }
}
__decorate([
    soapAttribute()
], Rotation.prototype, "angle", void 0);
export class SetArticleProperties extends SoapRequestData {
    static FromSoap(pSoapData) {
        if (pSoapData == null)
            return (undefined);
        const tSetProps = new SetArticleProperties();
        tSetProps.partIds = SoapService.SoapDataToArray(pSoapData.partIds);
        tSetProps.allPartIds = SoapService.SoapDataToArray(pSoapData.allPartIds);
        tSetProps.collapsed = SoapService.SoapDataToBool(pSoapData.collapsed);
        return (tSetProps);
    }
}
__decorate([
    soapAttribute()
], SetArticleProperties.prototype, "collapsed", void 0);
export class SetPropertyValueOptions extends SoapRequestData {
}
__decorate([
    soapAttribute()
], SetPropertyValueOptions.prototype, "computeVisibilityChangeFlags", void 0);
__decorate([
    soapAttribute()
], SetPropertyValueOptions.prototype, "computeValueChangeFlags", void 0);
__decorate([
    soapAttribute()
], SetPropertyValueOptions.prototype, "computeChoiceListChangeFlags", void 0);
export class SortGroup extends SoapRequestData {
    constructor() {
        super();
        this.position = 0;
    }
    static FromSoapArray(pSoapArray) {
        return (SoapService.SoapDataToArray(pSoapArray, SortGroup.FromSoapNU));
    }
    static FromSoapNU(pSoapData) {
        if (pSoapData == null)
            throw new Error(ERR_INVALID_ARGUMENT);
        const tGroup = new SortGroup();
        tGroup.selector = SortGroupSelector.FromSoapArray(pSoapData.selector);
        tGroup.sortOrder = ColumnSortOrder.FromSoapArray(pSoapData.sortOrder);
        tGroup.position = SoapService.SoapDataToInt(pSoapData.position);
        return (tGroup);
    }
}
__decorate([
    soapAttribute()
], SortGroup.prototype, "position", void 0);
export class SortGroupSelector extends SoapRequestData {
    static FromSoapArray(pSoapArray) {
        return (SoapService.SoapDataToArray(pSoapArray, SortGroupSelector.FromSoapNU));
    }
    static FromSoapNU(pSoapData) {
        if (pSoapData == null)
            throw new Error(ERR_INVALID_ARGUMENT);
        const tSelector = new SortGroupSelector();
        tSelector.itemType = pSoapData.itemType;
        tSelector.itemId = pSoapData.itemId;
        return (tSelector);
    }
}
__decorate([
    soapAttribute()
], SortGroupSelector.prototype, "itemType", void 0);
__decorate([
    soapAttribute()
], SortGroupSelector.prototype, "itemId", void 0);
export class TextItemProperties extends SoapRequestData {
    /** @internal */
    _getPropertyValue(pProperty) {
        //handle extra displayText array wrapper
        if (pProperty === "displayText")
            return (this.displayText != null ? { text: this.displayText } : undefined);
        //handle extra longDisplayText array wrapper
        if (pProperty === "longDisplayText")
            return (this.longDisplayText != null ? { text: this.longDisplayText } : undefined);
        return (super._getPropertyValue(pProperty));
    }
    static FromSoap(pSoapData) {
        var _a, _b;
        if (pSoapData == null)
            return (undefined);
        const tTextProps = new TextItemProperties();
        tTextProps.text = pSoapData.text;
        //handle extra displayText array wrapper
        tTextProps.displayText = DisplayText.FromSoapArray((_a = pSoapData.displayText) === null || _a === void 0 ? void 0 : _a.text);
        //handle extra longDisplayText array wrapper
        tTextProps.longDisplayText = DisplayText.FromSoapArray((_b = pSoapData.longDisplayText) === null || _b === void 0 ? void 0 : _b.text);
        return (tTextProps);
    }
}
export class Vector3 extends SoapRequestData {
    constructor() {
        super();
        this.x = 0;
        this.y = 0;
        this.z = 0;
    }
    static FromSoap(pSoapData) {
        if (pSoapData == null)
            return (undefined);
        const tVector = new Vector3();
        tVector.x = SoapService.SoapDataToFloat(pSoapData.x);
        tVector.y = SoapService.SoapDataToFloat(pSoapData.y);
        tVector.z = SoapService.SoapDataToFloat(pSoapData.z);
        return (tVector);
    }
    static FromSoapNU(pSoapData) {
        if (pSoapData == null)
            throw new Error(ERR_INVALID_ARGUMENT);
        return (Vector3.FromSoap(pSoapData));
    }
}
__decorate([
    soapAttribute()
], Vector3.prototype, "x", void 0);
__decorate([
    soapAttribute()
], Vector3.prototype, "y", void 0);
__decorate([
    soapAttribute()
], Vector3.prototype, "z", void 0);
export class Value extends SoapRequestData {
    static FromSoap(pSoapData) {
        if (pSoapData == null)
            return (undefined);
        let tXsiType = pSoapData["xsi:type"];
        if (tXsiType == null)
            tXsiType = "";
        let tValue = undefined;
        if (tXsiType.indexOf("Quantity") > -1) {
            const tQuantity = new Quantity();
            tQuantity.unit = pSoapData.unit;
            tValue = tQuantity;
        }
        else if (tXsiType.indexOf("Money") > -1) {
            const tMoney = new Money();
            tMoney.currency = pSoapData.currency;
            tValue = tMoney;
        }
        else if (tXsiType.indexOf("Percentage") > -1) {
            tValue = new Percentage();
        }
        else {
            tValue = new Value();
        }
        tValue.value = SoapService.SoapDataToDecimal(pSoapData.value);
        return (tValue);
    }
}
__decorate([
    soapAttribute()
], Value.prototype, "value", void 0);
export class Money extends Value {
    constructor() {
        super();
        this.currency = "";
    }
    static FromSoap(pSoapData) {
        if (pSoapData == null)
            return (undefined);
        const tMoney = new Money();
        tMoney.currency = pSoapData.currency;
        tMoney.value = SoapService.SoapDataToDecimal(pSoapData.value);
        return (tMoney);
    }
}
__decorate([
    soapAttribute()
], Money.prototype, "currency", void 0);
export class Percentage extends Value {
}
export class Quantity extends Value {
    constructor() {
        super();
        this.unit = "";
    }
    static FromSoap(pSoapData) {
        if (pSoapData == null)
            return (undefined);
        const tQuantity = new Quantity();
        tQuantity.unit = pSoapData.unit;
        tQuantity.value = SoapService.SoapDataToDecimal(pSoapData.value);
        return (tQuantity);
    }
}
__decorate([
    soapAttribute()
], Quantity.prototype, "unit", void 0);
////////
// response types
export class ArticleData {
    getProperty(pPropClass, pPropName) {
        if (this.properties == null)
            return (null);
        for (let i = 0; i < this.properties.length; ++i) {
            if (this.properties[i].propClass === pPropClass &&
                this.properties[i].propName === pPropName) {
                return (this.properties[i]);
            }
        }
        return (null);
    }
    getPropertyValue(pPropClass, pPropName) {
        const tProperty = this.getProperty(pPropClass, pPropName);
        if (tProperty != null)
            return (tProperty.value);
        else
            return (null);
    }
    static FromSoapNU(pSoapData) {
        if (pSoapData == null)
            throw new Error(ERR_INVALID_ARGUMENT);
        const tData = new ArticleData();
        tData.baseArticleNumber = pSoapData.baseArticleNumber;
        tData.catalogIcon = pSoapData.catalogIcon;
        tData.catalogImage = pSoapData.catalogImage;
        tData.currency = pSoapData.currency;
        tData.descriptionMode = pSoapData.descriptionMode;
        tData.featureText = pSoapData.featureText;
        tData.longText = pSoapData.longText;
        tData.manufacturerId = pSoapData.manufacturerId;
        tData.seriesId = pSoapData.seriesId;
        tData.shortText = pSoapData.shortText;
        tData.variantCode = pSoapData.variantCode;
        tData.pdPurchasePrice = SoapService.SoapDataToDecimal(pSoapData.pdPurchasePrice);
        tData.pdPurchasePriceComponents = PriceComponent.FromSoapArray(pSoapData.pdPurchasePriceComponents);
        tData.pdSalesPrice = SoapService.SoapDataToDecimal(pSoapData.pdSalesPrice);
        tData.pdSalesPriceComponents = PriceComponent.FromSoapArray(pSoapData.pdSalesPriceComponents);
        tData.properties = Property.FromSoapArray(pSoapData.properties);
        tData.propertyClasses = PropertyClass.FromSoapArray(pSoapData.propertyClasses);
        tData.purchaseCurrency = pSoapData.purchaseCurrency;
        tData.salesCurrency = pSoapData.salesCurrency;
        tData.priceDateSupported = SoapService.SoapDataToBool(pSoapData.priceDateSupported);
        tData.priceDateEditable = SoapService.SoapDataToBool(pSoapData.priceDateEditable);
        tData.priceDate = pSoapData.priceDate;
        return (tData);
    }
}
export class ArticleFeature {
    static FromSoapArrayNU(pSoapArray) {
        return (SoapService.SoapDataToArrayNU(pSoapArray, ArticleFeature.FromSoapNU));
    }
    static FromSoapNU(pSoapData) {
        if (pSoapData == null)
            throw new Error(ERR_INVALID_ARGUMENT);
        const tFeature = new ArticleFeature();
        tFeature.displayName = pSoapData.displayName;
        tFeature.displayValue = pSoapData.displayValue;
        tFeature.symbolicName = pSoapData.symbolicName;
        tFeature.symbolicValue = pSoapData.symbolicValue;
        tFeature.visible = SoapService.SoapDataToBool(pSoapData.visible);
        return (tFeature);
    }
}
export class BasketItem {
    /**
     * Returns this.mainArticleId if it is a valid id or this.itemId otherwise.
     * Returns undefined if this.mainArticleId is undefined.
     */
    getMainArticleId() {
        if (this.mainArticleId == null)
            return (undefined);
        if (this.mainArticleId === "" || this.mainArticleId === "00000000-0000-0000-0000-000000000000") {
            return (this.itemId);
        }
        else {
            return (this.mainArticleId);
        }
    }
    static FromSoapArray(pSoapArray) {
        return (SoapService.SoapDataToArray(pSoapArray, BasketItem.FromSoapNU));
    }
    static FromSoapArrayNU(pSoapArray) {
        return (SoapService.SoapDataToArrayNU(pSoapArray, BasketItem.FromSoapNU));
    }
    static FromSoapNU(pSoapData) {
        if (pSoapData == null)
            throw new Error(ERR_INVALID_ARGUMENT);
        const tItem = new BasketItem();
        tItem.itemId = pSoapData.itemId;
        tItem.itemType = pSoapData.itemType;
        tItem.label = pSoapData.label;
        tItem.mainArticleId = pSoapData.mainArticleId;
        tItem.subArticleIds = SoapService.SoapDataToArray(pSoapData.subArticleIds);
        tItem.subItemIds = SoapService.SoapDataToArray(pSoapData.subItemIds);
        tItem.setArticlePartIds = SoapService.SoapDataToArray(pSoapData.setArticlePartIds);
        tItem.basketItemIds = SoapService.SoapDataToArray(pSoapData.basketItemIds);
        tItem.basketItems = BasketItem.FromSoapArray(pSoapData.basketItems);
        tItem.setArticleId = pSoapData.setArticleId;
        tItem.geometryId = pSoapData.geometryId;
        tItem.positionNumber = pSoapData.positionNumber;
        return (tItem);
    }
}
export class BasketServiceFault {
    static FromSoap(pSoapData) {
        if (pSoapData == null)
            return (undefined);
        const tFault = new BasketServiceFault();
        tFault.message = pSoapData.message;
        tFault.partCompositionFailures = PartCompositionFailure.FromSoapArray(pSoapData.partCompositionFailures);
        return (tFault);
    }
}
export class CalculationLine {
    static FromSoapArrayNU(pSoapArray) {
        return (SoapService.SoapDataToArrayNU(pSoapArray, CalculationLine.FromSoapNU));
    }
    static FromSoapNU(pSoapData) {
        if (pSoapData == null)
            throw new Error(ERR_INVALID_ARGUMENT);
        const tLine = new CalculationLine();
        tLine.inactive = SoapService.SoapDataToArray(pSoapData.inactive);
        tLine.description = pSoapData.description;
        tLine.amount = Value.FromSoap(pSoapData.amount);
        tLine.qtyRelation = Quantity.FromSoap(pSoapData.qtyRelation);
        tLine.value = Money.FromSoap(pSoapData.value);
        tLine.groupError = CSValidationError.FromSoap(pSoapData.groupError);
        tLine.error = CSValidationError.FromSoap(pSoapData.error);
        tLine.level = SoapService.SoapDataToInt(pSoapData.level);
        tLine.counter = SoapService.SoapDataToInt(pSoapData.counter);
        tLine.conditionType = pSoapData.conditionType;
        tLine.conditionRemovable = SoapService.SoapDataToBool(pSoapData.conditionRemovable);
        tLine.amountEditable = SoapService.SoapDataToBool(pSoapData.amountEditable);
        tLine.amountEdited = SoapService.SoapDataToBool(pSoapData.amountEdited);
        tLine.qtyRelationEditable = SoapService.SoapDataToBool(pSoapData.qtyRelationEditable);
        tLine.valueEditable = SoapService.SoapDataToBool(pSoapData.valueEditable);
        return (tLine);
    }
}
export class CalculationSheet {
    static FromSoapNU(pSoapData) {
        if (pSoapData == null)
            throw new Error(ERR_INVALID_ARGUMENT);
        const tSheet = new CalculationSheet();
        tSheet.quantity = Quantity.FromSoap(pSoapData.quantity);
        tSheet.netValue = Money.FromSoap(pSoapData.netValue);
        tSheet.tax = Money.FromSoap(pSoapData.tax);
        tSheet.lines = CalculationLine.FromSoapArrayNU(pSoapData.lines);
        tSheet.addableConditions = SoapService.SoapDataToArrayNU(pSoapData.addableConditions);
        tSheet.currency = pSoapData.currency;
        return (tSheet);
    }
}
export class ChoiceList {
    static FromSoapArrayNU(pSoapArray) {
        return (SoapService.SoapDataToArrayNU(pSoapArray, ChoiceList.FromSoapNU));
    }
    static FromSoapNU(pSoapData) {
        if (pSoapData == null)
            throw new Error(ERR_INVALID_ARGUMENT);
        const tChoiceList = new ChoiceList();
        tChoiceList.propClass = pSoapData.propClass;
        tChoiceList.propName = pSoapData.propName;
        tChoiceList.values = PropertyValue.FromSoapArrayNU(pSoapData.values);
        return (tChoiceList);
    }
}
export class ConditionType {
    static FromSoapArrayNU(pSoapArray) {
        return (SoapService.SoapDataToArrayNU(pSoapArray, ConditionType.FromSoapNU));
    }
    static FromSoapNU(pSoapData) {
        if (pSoapData == null)
            throw new Error(ERR_INVALID_ARGUMENT);
        const tType = new ConditionType();
        tType.description = pSoapData.description;
        tType.accessMethod = pSoapData.accessMethod;
        tType.amountEditable = SoapService.SoapDataToBool(pSoapData.amountEditable);
        tType.calculationRule = pSoapData.calculationRule;
        tType.calculationRuleEditable = SoapService.SoapDataToBool(pSoapData.calculationRuleEditable);
        tType.conditionClass = pSoapData.conditionClass;
        tType.conditionDeletable = SoapService.SoapDataToBool(pSoapData.conditionDeletable);
        tType.conditionSign = pSoapData.conditionSign;
        tType.deferredCurrencyConversionEnabled = SoapService.SoapDataToBool(pSoapData.deferredCurrencyConversionEnabled);
        tType.editMode = pSoapData.editMode;
        tType.groupCondition = SoapService.SoapDataToBool(pSoapData.groupCondition);
        tType.headerCondition = SoapService.SoapDataToBool(pSoapData.headerCondition);
        tType.name = pSoapData.name;
        tType.quantityRelationEditable = SoapService.SoapDataToBool(pSoapData.quantityRelationEditable);
        tType.roundingRule = pSoapData.roundingRule;
        tType.valueEditable = SoapService.SoapDataToBool(pSoapData.valueEditable);
        return (tType);
    }
}
export class CSValidationError {
    static FromSoap(pSoapData) {
        if (pSoapData == null)
            return (undefined);
        let tXsiType = pSoapData["xsi:type"];
        if (tXsiType == null)
            tXsiType = "";
        let tError = undefined;
        if (tXsiType.indexOf("CSArithmeticOperationError") > -1) {
            const tExtendedError = new CSArithmeticOperationError();
            tExtendedError.operationKind = pSoapData.operationKind;
            tError = tExtendedError;
        }
        else if (tXsiType.indexOf("CSConformabilityError") > -1) {
            const tExtendedError = new CSConformabilityError();
            tExtendedError.operationKind = pSoapData.operationKind;
            tExtendedError.unit1 = pSoapData.unit1;
            tExtendedError.unit2 = pSoapData.unit2;
            tError = tExtendedError;
        }
        else if (tXsiType.indexOf("CSCurrencyError") > -1) {
            const tExtendedError = new CSCurrencyError();
            tExtendedError.operationKind = pSoapData.operationKind;
            tExtendedError.currency1 = pSoapData.currency1;
            tExtendedError.currency2 = pSoapData.currency2;
            tError = tExtendedError;
        }
        else if (tXsiType.indexOf("CSInvalidValueError") > -1) {
            const tExtendedError = new CSInvalidValueError();
            tExtendedError.parameterKind = pSoapData.parameterKind;
            tError = tExtendedError;
        }
        else if (tXsiType.indexOf("CSItemDataAccessError") > -1) {
            tError = new CSItemDataAccessError();
        }
        else if (tXsiType.indexOf("CSLineNotFoundError") > -1) {
            tError = new CSLineNotFoundError();
        }
        else if (tXsiType.indexOf("CSUndefinedOperationError") > -1) {
            const tExtendedError = new CSUndefinedOperationError();
            tExtendedError.calculationRule = pSoapData.calculationRule;
            tError = tExtendedError;
        }
        else {
            tError = new CSValidationError();
        }
        tError.message = pSoapData.message;
        tError.resultKind = pSoapData.resultKind;
        tError.errorCode = pSoapData.errorCode;
        return (tError);
    }
    static FromSoapNU(pSoapData) {
        if (pSoapData == null)
            throw new Error(ERR_INVALID_ARGUMENT);
        return (OAPAction.FromSoap(pSoapData));
    }
}
export class CSArithmeticOperationError extends CSValidationError {
}
export class CSConformabilityError extends CSValidationError {
}
export class CSCurrencyError extends CSValidationError {
}
export class CSInvalidValueError extends CSValidationError {
}
export class CSItemDataAccessError extends CSValidationError {
}
export class CSLineNotFoundError extends CSValidationError {
}
export class CSUndefinedOperationError extends CSValidationError {
}
export class ImageInfo {
    static FromSoapArrayNU(pSoapArray) {
        return (SoapService.SoapDataToArrayNU(pSoapArray, ImageInfo.FromSoapNU));
    }
    static FromSoapNU(pSoapData) {
        if (pSoapData == null)
            throw new Error(ERR_INVALID_ARGUMENT);
        const tInfo = new ImageInfo();
        tInfo.tag = pSoapData.tag;
        tInfo.url = pSoapData.url;
        tInfo.attributes = SoapService.SoapDataToArray(pSoapData.attributes);
        tInfo.itemId = pSoapData.itemId;
        return (tInfo);
    }
}
export class Interval {
    static FromSoapArray(pSoapArray) {
        return (SoapService.SoapDataToArray(pSoapArray, Interval.FromSoapNU));
    }
    static FromSoapNU(pSoapData) {
        if (pSoapData == null)
            throw new Error(ERR_INVALID_ARGUMENT);
        const tInterval = new Interval();
        tInterval.maxValue = SoapService.SoapDataToDecimal(pSoapData.maxValue);
        tInterval.minValue = SoapService.SoapDataToDecimal(pSoapData.minValue);
        return (tInterval);
    }
}
export class ItemCalculationSheet {
    static FromSoapArrayNU(pSoapArray) {
        return (SoapService.SoapDataToArrayNU(pSoapArray, ItemCalculationSheet.FromSoapNU));
    }
    static FromSoapNU(pSoapData) {
        if (pSoapData == null)
            throw new Error(ERR_INVALID_ARGUMENT);
        const tSheet = new ItemCalculationSheet();
        tSheet.id = pSoapData.id;
        tSheet.sheet = CalculationSheet.FromSoapNU(pSoapData.sheet);
        return (tSheet);
    }
}
export class ManufacturerInfo {
    static FromSoapArrayNU(pSoapArray) {
        return (SoapService.SoapDataToArrayNU(pSoapArray, ManufacturerInfo.FromSoapNU));
    }
    static FromSoapNU(pSoapData) {
        var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r;
        if (pSoapData == null)
            throw new Error(ERR_INVALID_ARGUMENT);
        const tInfo = new ManufacturerInfo();
        tInfo.manufacturerId = pSoapData.manufacturerId;
        tInfo.concernId = pSoapData.concernId;
        tInfo.supplierId = pSoapData.supplierId;
        tInfo.priceProfileRegionId = pSoapData.priceProfileRegionId;
        tInfo.externalCatalogURL = pSoapData.externalCatalogURL;
        //handle extra array wrappers
        tInfo.manufacturerName = DisplayText.FromSoapArray((_a = pSoapData.manufacturerName) === null || _a === void 0 ? void 0 : _a.text);
        tInfo.seriesInfos = SeriesInfo.FromSoapArray((_b = pSoapData.seriesInfos) === null || _b === void 0 ? void 0 : _b.seriesInfo);
        tInfo.distributorName = DisplayText.FromSoapArray((_c = pSoapData.distributorName) === null || _c === void 0 ? void 0 : _c.text);
        tInfo.copyright = DisplayText.FromSoapArray((_d = pSoapData.copyright) === null || _d === void 0 ? void 0 : _d.text);
        tInfo.addressName = DisplayText.FromSoapArray((_e = pSoapData.addressName) === null || _e === void 0 ? void 0 : _e.text);
        tInfo.addressStreet = DisplayText.FromSoapArray((_f = pSoapData.addressStreet) === null || _f === void 0 ? void 0 : _f.text);
        tInfo.addressCity = DisplayText.FromSoapArray((_g = pSoapData.addressCity) === null || _g === void 0 ? void 0 : _g.text);
        tInfo.addressState = DisplayText.FromSoapArray((_h = pSoapData.addressState) === null || _h === void 0 ? void 0 : _h.text);
        tInfo.addressPOBox = DisplayText.FromSoapArray((_j = pSoapData.addressPOBox) === null || _j === void 0 ? void 0 : _j.text);
        tInfo.addressZIP = DisplayText.FromSoapArray((_k = pSoapData.addressZIP) === null || _k === void 0 ? void 0 : _k.text);
        tInfo.addressCountry = DisplayText.FromSoapArray((_l = pSoapData.addressCountry) === null || _l === void 0 ? void 0 : _l.text);
        tInfo.addressEMail = DisplayText.FromSoapArray((_m = pSoapData.addressEMail) === null || _m === void 0 ? void 0 : _m.text);
        tInfo.addressPhone = DisplayText.FromSoapArray((_o = pSoapData.addressPhone) === null || _o === void 0 ? void 0 : _o.text);
        tInfo.addressFAX = DisplayText.FromSoapArray((_p = pSoapData.addressFAX) === null || _p === void 0 ? void 0 : _p.text);
        tInfo.addressWWW = DisplayText.FromSoapArray((_q = pSoapData.addressWWW) === null || _q === void 0 ? void 0 : _q.text);
        tInfo.externalCatalogName = DisplayText.FromSoapArray((_r = pSoapData.externalCatalogName) === null || _r === void 0 ? void 0 : _r.text);
        return (tInfo);
    }
}
export class MergeResult {
    static FromSoapNU(pSoapData) {
        if (pSoapData == null)
            throw new Error(ERR_INVALID_ARGUMENT);
        const tResult = new MergeResult();
        tResult.addedItems = SoapService.SoapDataToArray(pSoapData.addedItems);
        tResult.removedItems = SoapService.SoapDataToArray(pSoapData.removedItems);
        tResult.movedItems = SoapService.SoapDataToArray(pSoapData.movedItems);
        tResult.updatedItems = SoapService.SoapDataToArray(pSoapData.updatedItems);
        return (tResult);
    }
}
export class OAPAction {
    static FromSoap(pSoapData) {
        if (pSoapData == null)
            return (undefined);
        let tXsiType = pSoapData["xsi:type"];
        if (tXsiType == null)
            tXsiType = "";
        let tAction = undefined;
        if (tXsiType.indexOf("OAPActionChoiceAction") > -1) {
            const tActionChoice = new OAPActionChoiceAction();
            tActionChoice.title = pSoapData.title;
            tActionChoice.actions = OAPActionListItem.FromSoapArrayNU(pSoapData.actions);
            tActionChoice.viewType = pSoapData.viewType;
            tActionChoice.tileSize = pSoapData.tileSize;
            tAction = tActionChoice;
        }
        else if (tXsiType.indexOf("OAPPropChangeAction") > -1) {
            const tPropChange = new OAPPropChangeAction();
            tPropChange.type = pSoapData.type;
            tPropChange.property = pSoapData.property;
            tPropChange.value = pSoapData.value;
            tAction = tPropChange;
        }
        else if (tXsiType.indexOf("OAPPropEditAction") > -1) {
            const tPropEdit = new OAPPropEditAction();
            tPropEdit.title = pSoapData.title;
            tPropEdit.properties = SoapService.SoapDataToArray(pSoapData.properties);
            tPropEdit.propertyClasses = SoapService.SoapDataToArray(pSoapData.propertyClasses);
            tPropEdit.visibleOnly = SoapService.SoapDataToBool(pSoapData.visibleOnly);
            tPropEdit.editableOnly = SoapService.SoapDataToBool(pSoapData.editableOnly);
            tAction = tPropEdit;
        }
        else if (tXsiType.indexOf("OAPPropEdit2Action") > -1) {
            const tPropEdit2 = new OAPPropEdit2Action();
            tPropEdit2.title = pSoapData.title;
            tPropEdit2.properties = OAPPropEditProp.FromSoapArray(pSoapData.properties);
            tPropEdit2.propertyClasses = OAPPropEditClass.FromSoapArray(pSoapData.propertyClasses);
            tAction = tPropEdit2;
        }
        else if (tXsiType.indexOf("OAPCreateObjectAction") > -1) {
            const tCreate = new OAPCreateObjectAction();
            tCreate.parent = OAPObjectDefinition.FromSoap(pSoapData.parent);
            tCreate.ofmlVariantCode = pSoapData.ofmlVariantCode;
            tCreate.initialPlacement = OAPPlacement.FromSoap(pSoapData.initialPlacement);
            tCreate.articleSpecMode = pSoapData.articleSpecMode;
            tCreate.packageId = pSoapData.packageId;
            tCreate.baseArticleNumber = pSoapData.baseArticleNumber;
            tAction = tCreate;
        }
        else if (tXsiType.indexOf("OAPMethodCallAction") > -1) {
            const tMethod = new OAPMethodCallAction();
            tMethod.type = pSoapData.type;
            tMethod.context = pSoapData.context;
            tMethod.method = pSoapData.method;
            tMethod.arguments = pSoapData.arguments;
            tAction = tMethod;
        }
        else if (tXsiType.indexOf("OAPMessageAction") > -1) {
            const tMethod = new OAPMessageAction();
            tMethod.text = pSoapData.text;
            tAction = tMethod;
        }
        else if (tXsiType.indexOf("OAPDeleteObjectAction") > -1) {
            tAction = new OAPDeleteObjectAction();
        }
        else if (tXsiType.indexOf("OAPSelectObjectAction") > -1) {
            tAction = new OAPSelectObjectAction();
        }
        else if (tXsiType.indexOf("OAPShowMediaAction") > -1) {
            const tShowMedia = new OAPShowMediaAction();
            tShowMedia.mediaSource = pSoapData.mediaSource;
            tShowMedia.mediaId = pSoapData.mediaId;
            tAction = tShowMedia;
        }
        else if (tXsiType.indexOf("OAPDimChangeAction") > -1) {
            const tDimChange = new OAPDimChangeAction();
            tDimChange.dimChanges = OAPDimChange.FromSoapArray(pSoapData.dimChanges);
            tAction = tDimChange;
        }
        else if (tXsiType.indexOf("OAPDimChange2Action") > -1) {
            const tDimChange2 = new OAPDimChange2Action();
            tDimChange2.dimChanges = OAPDimChange.FromSoapArray(pSoapData.dimChanges);
            tAction = tDimChange2;
        }
        else {
            Log.warn("Unknown OAPAction type: " + tXsiType);
            tAction = new OAPAction();
        }
        tAction.objects = OAPObjectDefinition.FromSoapArray(pSoapData.objects);
        tAction.id = pSoapData.id;
        return (tAction);
    }
    static FromSoapNU(pSoapData) {
        if (pSoapData == null)
            throw new Error(ERR_INVALID_ARGUMENT);
        return (OAPAction.FromSoap(pSoapData));
    }
}
export class OAPActionChoiceAction extends OAPAction {
}
export class OAPCreateObjectAction extends OAPAction {
}
export class OAPDeleteObjectAction extends OAPAction {
}
export class OAPDimChangeAction extends OAPAction {
}
export class OAPDimChange2Action extends OAPAction {
}
export class OAPMethodCallAction extends OAPAction {
}
export class OAPMessageAction extends OAPAction {
}
export class OAPPropChangeAction extends OAPAction {
}
export class OAPPropEditAction extends OAPAction {
}
export class OAPPropEdit2Action extends OAPAction {
}
export class OAPSelectObjectAction extends OAPAction {
}
export class OAPShowMediaAction extends OAPAction {
}
export class OAPActionResult {
    static FromSoapArray(pSoapArray) {
        return (SoapService.SoapDataToArray(pSoapArray, OAPActionResult.FromSoapNU));
    }
    static FromSoapArrayNU(pSoapArray) {
        return (SoapService.SoapDataToArrayNU(pSoapArray, OAPActionResult.FromSoapNU));
    }
    static FromSoapNU(pSoapData) {
        if (pSoapData == null)
            throw new Error(ERR_INVALID_ARGUMENT);
        const tResult = new OAPActionResult();
        tResult.actionData = OAPAction.FromSoap(pSoapData.actionData);
        tResult.objects = SoapService.SoapDataToArray(pSoapData.objects);
        tResult.referenceObject = pSoapData.referenceObject;
        tResult.newObjectPosition = Vector3.FromSoap(pSoapData.newObjectPosition);
        tResult.newObjectRotation = Rotation.FromSoap(pSoapData.newObjectRotation);
        tResult.addedItems = SoapService.SoapDataToArray(pSoapData.addedItems);
        tResult.removedItems = SoapService.SoapDataToArray(pSoapData.removedItems);
        tResult.movedItems = SoapService.SoapDataToArray(pSoapData.movedItems);
        tResult.updatedItems = SoapService.SoapDataToArray(pSoapData.updatedItems);
        tResult.id = pSoapData.id;
        tResult.state = pSoapData.state;
        return (tResult);
    }
}
export class OAPActionListItem {
    static FromSoapArrayNU(pSoapArray) {
        return (SoapService.SoapDataToArrayNU(pSoapArray, OAPActionListItem.FromSoapNU));
    }
    static FromSoapNU(pSoapData) {
        if (pSoapData == null)
            throw new Error(ERR_INVALID_ARGUMENT);
        const tItem = new OAPActionListItem();
        tItem.action = OAPAction.FromSoap(pSoapData.action);
        tItem.actionIds = SoapService.SoapDataToArray(pSoapData.actionIds);
        tItem.text = pSoapData.text;
        tItem.imageFile = pSoapData.imageFile;
        return (tItem);
    }
}
export class OAPDimChange {
    static FromSoapArray(pSoapArray) {
        return (SoapService.SoapDataToArray(pSoapArray, OAPDimChange.FromSoapNU));
    }
    static FromSoapNU(pSoapData) {
        if (pSoapData == null)
            throw new Error(ERR_INVALID_ARGUMENT);
        const tDimChange = new OAPDimChange();
        tDimChange.propChoiceList = SoapService.SoapDataToArray(pSoapData.propChoiceList, SoapService.SoapDataToDecimal);
        tDimChange.symbolicPropValues = SoapService.SoapDataToArray(pSoapData.symbolicPropValues);
        tDimChange.axis = pSoapData.axis;
        tDimChange.dimension = pSoapData.dimension;
        tDimChange.propClass = pSoapData.propClass;
        tDimChange.propName = pSoapData.propName;
        tDimChange.propValue = SoapService.SoapDataToDecimal(pSoapData.propValue);
        tDimChange.minPropValue = SoapService.SoapDataToDecimal(pSoapData.minPropValue);
        tDimChange.maxPropValue = SoapService.SoapDataToDecimal(pSoapData.maxPropValue);
        tDimChange.fixedValue = SoapService.SoapDataToBool(pSoapData.fixedValue);
        tDimChange.propDecDigits = SoapService.SoapDataToInt(pSoapData.propDecDigits);
        tDimChange.multiplier = SoapService.SoapDataToDecimal(pSoapData.multiplier);
        tDimChange.precision = SoapService.SoapDataToDecimal(pSoapData.precision);
        tDimChange.changeSeparately = SoapService.SoapDataToBool(pSoapData.changeSeparately);
        tDimChange.thirdDimension = SoapService.SoapDataToBool(pSoapData.thirdDimension);
        return (tDimChange);
    }
}
export class OAPInteractor {
    static FromSoapArrayNU(pSoapArray) {
        return (SoapService.SoapDataToArrayNU(pSoapArray, OAPInteractor.FromSoapNU));
    }
    static FromSoapNU(pSoapData) {
        if (pSoapData == null)
            throw new Error(ERR_INVALID_ARGUMENT);
        const tInteractor = new OAPInteractor();
        tInteractor.symbolOffset = Vector3.FromSoap(pSoapData.symbolOffset);
        tInteractor.actionIds = SoapService.SoapDataToArray(pSoapData.actionIds);
        tInteractor.symbols = OAPSymbolDisplay.FromSoapArray(pSoapData.symbols);
        tInteractor.directActionIds = SoapService.SoapDataToArray(pSoapData.directActionIds);
        tInteractor.directActions = OAPActionResult.FromSoapArray(pSoapData.directActions);
        tInteractor.id = pSoapData.id;
        tInteractor.symbolType = pSoapData.symbolType;
        tInteractor.symbolSize = pSoapData.symbolSize;
        return (tInteractor);
    }
}
export class OAPObjectDefinition {
    static FromSoapArray(pSoapArray) {
        return (SoapService.SoapDataToArray(pSoapArray, OAPObjectDefinition.FromSoapNU));
    }
    static FromSoap(pSoapData) {
        if (pSoapData == null)
            return (undefined);
        const tDef = new OAPObjectDefinition();
        tDef.arguments = SoapService.SoapDataToArray(pSoapData.arguments);
        tDef.category = pSoapData.category;
        return (tDef);
    }
    static FromSoapNU(pSoapData) {
        if (pSoapData == null)
            throw new Error(ERR_INVALID_ARGUMENT);
        return (OAPObjectDefinition.FromSoap(pSoapData));
    }
}
export class OAPPropEditClass {
    static FromSoapArray(pSoapArray) {
        return (SoapService.SoapDataToArray(pSoapArray, OAPPropEditClass.FromSoapNU));
    }
    static FromSoapNU(pSoapData) {
        if (pSoapData == null)
            throw new Error(ERR_INVALID_ARGUMENT);
        const tClass = new OAPPropEditClass();
        tClass.propClass = pSoapData.propClass;
        tClass.visibleOnly = SoapService.SoapDataToBool(pSoapData.visibleOnly);
        tClass.editableOnly = SoapService.SoapDataToBool(pSoapData.editableOnly);
        return (tClass);
    }
}
export class OAPPropEditProp {
    static FromSoapArray(pSoapArray) {
        return (SoapService.SoapDataToArray(pSoapArray, OAPPropEditProp.FromSoapNU));
    }
    static FromSoapNU(pSoapData) {
        if (pSoapData == null)
            throw new Error(ERR_INVALID_ARGUMENT);
        const tProp = new OAPPropEditProp();
        tProp.propClass = pSoapData.propClass;
        tProp.propName = pSoapData.propName;
        tProp.visibleOnly = SoapService.SoapDataToBool(pSoapData.visibleOnly);
        tProp.editableOnly = SoapService.SoapDataToBool(pSoapData.editableOnly);
        return (tProp);
    }
}
export class OAPSymbolDisplay {
    static FromSoapArray(pSoapArray) {
        return (SoapService.SoapDataToArrayNU(pSoapArray, OAPSymbolDisplay.FromSoapNU));
    }
    static FromSoapNU(pSoapData) {
        if (pSoapData == null)
            throw new Error(ERR_INVALID_ARGUMENT);
        const tSymbol = new OAPSymbolDisplay();
        tSymbol.symbolOffset = Vector3.FromSoap(pSoapData.symbolOffset);
        tSymbol.direction = Vector3.FromSoap(pSoapData.direction);
        tSymbol.orientationX = Vector3.FromSoap(pSoapData.orientationX);
        tSymbol.viewAngle = SoapService.SoapDataToFloat(pSoapData.viewAngle);
        tSymbol.hiddenMode = SoapService.SoapDataToBool(pSoapData.hiddenMode);
        return (tSymbol);
    }
}
export class OAPPlacement {
    static FromSoap(pSoapData) {
        if (pSoapData == null)
            return (undefined);
        let tXsiType = pSoapData["xsi:type"];
        if (tXsiType == null)
            tXsiType = "";
        let tPlacement = undefined;
        if (tXsiType.indexOf("OAPDataDefinedPlacement") > -1) {
            const tAppPlacement = new OAPDataDefinedPlacement();
            tAppPlacement.referenceObject = OAPObjectDefinition.FromSoap(pSoapData.referenceObject);
            tAppPlacement.attachPoint = pSoapData.attachPoint;
            tPlacement = tAppPlacement;
        }
        else if (tXsiType.indexOf("OAPAttachAreasPlacement") > -1) {
            const tAttachPlacement = new OAPAttachAreasPlacement();
            tAttachPlacement.referenceObject = OAPObjectDefinition.FromSoapNU(pSoapData.referenceObject);
            tAttachPlacement.refObjectAttachAreaIds = SoapService.SoapDataToArrayNU(pSoapData.refObjectAttachAreaIds);
            tAttachPlacement.newObjectAttachAreaId = pSoapData.newObjectAttachAreaId;
            tPlacement = tAttachPlacement;
        }
        else {
            Log.warn("Unknown OAPPlacement type: " + tXsiType);
            tPlacement = new OAPPlacement();
        }
        return (tPlacement);
    }
}
export class OAPDataDefinedPlacement extends OAPPlacement {
}
export class OAPAttachAreasPlacement extends OAPPlacement {
}
export class OrderedTax {
    static FromSoapArray(pSoapArray) {
        return (SoapService.SoapDataToArray(pSoapArray, OrderedTax.FromSoapNU));
    }
    static FromSoapNU(pSoapData) {
        if (pSoapData == null)
            throw new Error(ERR_INVALID_ARGUMENT);
        const tTax = new OrderedTax();
        tTax.order = SoapService.SoapDataToInt(pSoapData.order);
        tTax.typeId = pSoapData.typeId;
        return (tTax);
    }
}
export class PartCompositionFailure {
    static FromSoapArray(pSoapArray) {
        return (SoapService.SoapDataToArray(pSoapArray, PartCompositionFailure.FromSoapNU));
    }
    static FromSoapNU(pSoapData) {
        if (pSoapData == null)
            throw new Error(ERR_INVALID_ARGUMENT);
        const tFailure = new PartCompositionFailure();
        tFailure.itemId = pSoapData.itemId;
        tFailure.cause = SoapService.SoapDataToArray(pSoapData.cause);
        return (tFailure);
    }
}
export class PasteContainerResult {
    static FromSoap(pSoapData) {
        if (pSoapData == null)
            return (undefined);
        const tResult = new PasteContainerResult();
        tResult.items = BasketItem.FromSoapArrayNU(pSoapData.items);
        tResult.itemGeometries = SoapService.SoapDataToArrayNU(pSoapData.itemGeometries);
        tResult.originalItemIds = SoapService.SoapDataToArray(pSoapData.originalItemIds);
        tResult.sceneGeometry = pSoapData.sceneGeometry;
        return (tResult);
    }
}
export class PriceInfo {
    static FromSoap(pSoapData) {
        if (pSoapData == null)
            return (undefined);
        const tInfo = new PriceInfo();
        tInfo.unitSize = Quantity.FromSoap(pSoapData.unitSize);
        tInfo.netPrice = Money.FromSoap(pSoapData.netPrice);
        tInfo.netValue = Money.FromSoap(pSoapData.netValue);
        tInfo.tax = Money.FromSoap(pSoapData.tax);
        tInfo.extraPriceInfos = PriceInfoElement.FromSoapArray(pSoapData.extraPriceInfos);
        tInfo.inactive = SoapService.SoapDataToBool(pSoapData.inactive);
        tInfo.quantity = SoapService.SoapDataToDecimal(pSoapData.quantity);
        return (tInfo);
    }
}
export class PriceInfoElement {
    static FromSoapArray(pSoapArray) {
        return (SoapService.SoapDataToArray(pSoapArray, PriceInfoElement.FromSoapNU));
    }
    static FromSoapNU(pSoapData) {
        if (pSoapData == null)
            throw new Error(ERR_INVALID_ARGUMENT);
        const pElement = new PriceInfoElement();
        pElement.value = Value.FromSoap(pSoapData.value);
        pElement.selector = pSoapData.selector;
        return (pElement);
    }
}
export class PriceComponent {
    static FromSoapArray(pSoapArray) {
        return (SoapService.SoapDataToArray(pSoapArray, PriceComponent.FromSoapNU));
    }
    static FromSoapNU(pSoapData) {
        if (pSoapData == null)
            throw new Error(ERR_INVALID_ARGUMENT);
        const tComponent = new PriceComponent();
        tComponent.name = pSoapData.name;
        tComponent.value = SoapService.SoapDataToDecimal(pSoapData.value);
        return (tComponent);
    }
}
export class PricingProcedure {
    static FromSoapNU(pSoapData) {
        if (pSoapData == null)
            throw new Error(ERR_INVALID_ARGUMENT);
        const tProc = new PricingProcedure();
        tProc.displayName = pSoapData.displayName;
        tProc.lines = PricingProcedureLine.FromSoapArrayNU(pSoapData.lines);
        tProc.halfWayRoundingMode = pSoapData.halfWayRoundingMode;
        tProc.name = pSoapData.name;
        return (tProc);
    }
}
export class PricingProcedureDescription {
    static FromSoapArrayNU(pSoapArray) {
        return (SoapService.SoapDataToArrayNU(pSoapArray, PricingProcedureDescription.FromSoapNU));
    }
    static FromSoapNU(pSoapData) {
        if (pSoapData == null)
            throw new Error(ERR_INVALID_ARGUMENT);
        const tDesc = new PricingProcedureDescription();
        tDesc.displayName = pSoapData.displayName;
        tDesc.name = pSoapData.name;
        return (tDesc);
    }
}
export class PricingProcedureLine {
    static FromSoapArrayNU(pSoapArray) {
        return (SoapService.SoapDataToArrayNU(pSoapArray, PricingProcedureLine.FromSoapNU));
    }
    static FromSoapNU(pSoapData) {
        if (pSoapData == null)
            throw new Error(ERR_INVALID_ARGUMENT);
        const tLine = new PricingProcedureLine();
        tLine.description = pSoapData.description;
        tLine.tags = SoapService.SoapDataToArray(pSoapData.tags);
        tLine.conditionType = pSoapData.conditionType;
        tLine.counter = SoapService.SoapDataToInt(pSoapData.counter);
        tLine.from = SoapService.SoapDataToInt(pSoapData.from);
        tLine.insertMode = pSoapData.insertMode;
        tLine.level = SoapService.SoapDataToInt(pSoapData.level);
        tLine.lineType = pSoapData.lineType;
        tLine.maxOccurs = SoapService.SoapDataToInt(pSoapData.maxOccurs);
        tLine.printControl = pSoapData.printControl;
        tLine.to = SoapService.SoapDataToInt(pSoapData.to);
        return (tLine);
    }
}
export class Property {
    static FromSoapArray(pSoapArray) {
        return (SoapService.SoapDataToArray(pSoapArray, Property.FromSoapNU));
    }
    static FromSoapNU(pSoapData) {
        if (pSoapData == null)
            throw new Error(ERR_INVALID_ARGUMENT);
        const tProperty = new Property();
        tProperty.addValues = SoapService.SoapDataToBool(pSoapData.addValues);
        tProperty.choiceList = SoapService.SoapDataToBool(pSoapData.choiceList);
        tProperty.decDigits = SoapService.SoapDataToInt(pSoapData.decDigits);
        tProperty.digits = SoapService.SoapDataToInt(pSoapData.digits);
        tProperty.editable = SoapService.SoapDataToBool(pSoapData.editable);
        tProperty.intervals = Interval.FromSoapArray(pSoapData.intervals);
        tProperty.propClass = pSoapData.propClass;
        tProperty.propName = pSoapData.propName;
        tProperty.propText = pSoapData.propText;
        tProperty.type = pSoapData.type;
        tProperty.value = PropertyValue.FromSoapNU(pSoapData.value);
        tProperty.visible = SoapService.SoapDataToBool(pSoapData.visible);
        tProperty.width = SoapService.SoapDataToInt(pSoapData.width);
        tProperty.multiLine = SoapService.SoapDataToBool(pSoapData.multiLine);
        return (tProperty);
    }
}
export class PropertyClass {
    static FromSoapArray(pSoapArray) {
        return (SoapService.SoapDataToArray(pSoapArray, PropertyClass.FromSoapNU));
    }
    static FromSoapNU(pSoapData) {
        if (pSoapData == null)
            throw new Error(ERR_INVALID_ARGUMENT);
        const tClass = new PropertyClass();
        tClass.description = pSoapData.description;
        tClass.name = pSoapData.name;
        return (tClass);
    }
}
export class PropertyValue {
    static FromSoapArray(pSoapArray) {
        return (SoapService.SoapDataToArray(pSoapArray, PropertyValue.FromSoapNU));
    }
    static FromSoapArrayNU(pSoapArray) {
        return (SoapService.SoapDataToArrayNU(pSoapArray, PropertyValue.FromSoapNU));
    }
    static FromSoapNU(pSoapData) {
        if (pSoapData == null)
            throw new Error(ERR_INVALID_ARGUMENT);
        const tValue = new PropertyValue();
        tValue.largeIcon = pSoapData.largeIcon;
        tValue.smallIcon = pSoapData.smallIcon;
        tValue.surcharge = Money.FromSoap(pSoapData.surcharge);
        tValue.text = pSoapData.text;
        tValue.value = pSoapData.value;
        tValue.image = pSoapData.image;
        tValue.selectable = SoapService.SoapDataToBool(pSoapData.selectable);
        return (tValue);
    }
}
export class SeriesInfo {
    static FromSoapArray(pSoapArray) {
        return (SoapService.SoapDataToArray(pSoapArray, SeriesInfo.FromSoapNU));
    }
    static FromSoapNU(pSoapData) {
        var _a;
        if (pSoapData == null)
            throw new Error(ERR_INVALID_ARGUMENT);
        const tInfo = new SeriesInfo();
        tInfo.seriesId = pSoapData.seriesId;
        //handle extra seriesName array wrapper
        tInfo.seriesName = DisplayText.FromSoapArray((_a = pSoapData.seriesName) === null || _a === void 0 ? void 0 : _a.text);
        return (tInfo);
    }
}
export class TaxCategory {
    static FromSoapArray(pSoapArray) {
        return (SoapService.SoapDataToArray(pSoapArray, TaxCategory.FromSoapNU));
    }
    static FromSoapNU(pSoapData) {
        if (pSoapData == null)
            throw new Error(ERR_INVALID_ARGUMENT);
        const tCategory = new TaxCategory();
        tCategory.name = pSoapData.name;
        tCategory.identifier = pSoapData.identifier;
        tCategory.rate = SoapService.SoapDataToDecimal(pSoapData.rate);
        tCategory.rateReadOnly = SoapService.SoapDataToBool(pSoapData.rateReadOnly);
        return (tCategory);
    }
}
export class TaxInfo {
    static FromSoapArrayNU(pSoapArray) {
        return (SoapService.SoapDataToArrayNU(pSoapArray, TaxInfo.FromSoapNU));
    }
    static FromSoapNU(pSoapData) {
        if (pSoapData == null)
            throw new Error(ERR_INVALID_ARGUMENT);
        const tInfo = new TaxInfo();
        tInfo.taxCategory = pSoapData.taxCategory;
        tInfo.taxType = pSoapData.taxType;
        return (tInfo);
    }
}
export class TaxScheme {
    static FromSoapNU(pSoapData) {
        if (pSoapData == null)
            throw new Error(ERR_INVALID_ARGUMENT);
        const tScheme = new TaxScheme();
        tScheme.variantName = pSoapData.variantName;
        tScheme.taxTypes = TaxType.FromSoapArray(pSoapData.taxTypes);
        tScheme.orderedTaxes = OrderedTax.FromSoapArray(pSoapData.orderedTaxes);
        tScheme.country = pSoapData.country;
        tScheme.currency = pSoapData.currency;
        tScheme.identifier = pSoapData.identifier;
        tScheme.region = pSoapData.region;
        return (tScheme);
    }
}
export class TaxType {
    static FromSoapArray(pSoapArray) {
        return (SoapService.SoapDataToArray(pSoapArray, TaxType.FromSoapNU));
    }
    static FromSoapNU(pSoapData) {
        if (pSoapData == null)
            throw new Error(ERR_INVALID_ARGUMENT);
        const tType = new TaxType();
        tType.abbreviation = pSoapData.abbreviation;
        tType.name = pSoapData.name;
        tType.taxCategories = TaxCategory.FromSoapArray(pSoapData.taxCategories);
        tType.identifier = pSoapData.identifier;
        tType.rateUnit = pSoapData.rateUnit;
        return (tType);
    }
}
export class TaxSchemeDescription {
    static FromSoapArrayNU(pSoapArray) {
        return (SoapService.SoapDataToArrayNU(pSoapArray, TaxSchemeDescription.FromSoapNU));
    }
    static FromSoapNU(pSoapData) {
        if (pSoapData == null)
            throw new Error(ERR_INVALID_ARGUMENT);
        const tDesc = new TaxSchemeDescription();
        tDesc.variantName = pSoapData.variantName;
        tDesc.country = pSoapData.country;
        tDesc.identifier = pSoapData.identifier;
        tDesc.region = pSoapData.region;
        return (tDesc);
    }
}
export class TMColumnDef {
    static FromSoapArrayNU(pSoapArray) {
        return (SoapService.SoapDataToArrayNU(pSoapArray, TMColumnDef.FromSoapNU));
    }
    static FromSoapNU(pSoapData) {
        if (pSoapData == null)
            throw new Error(ERR_INVALID_ARGUMENT);
        const tColumn = new TMColumnDef();
        tColumn.displayName = pSoapData.displayName;
        tColumn.columnId = pSoapData.columnId;
        return (tColumn);
    }
}
export class TMRow {
    static FromSoapArrayNU(pSoapArray) {
        return (SoapService.SoapDataToArrayNU(pSoapArray, TMRow.FromSoapNU));
    }
    static FromSoapArray(pSoapArray) {
        return (SoapService.SoapDataToArray(pSoapArray, TMRow.FromSoapNU));
    }
    static FromSoapNU(pSoapData) {
        if (pSoapData == null)
            throw new Error(ERR_INVALID_ARGUMENT);
        const tRow = new TMRow();
        tRow.texts = TMText.FromSoapArrayNU(pSoapData.texts);
        tRow.textId = pSoapData.textId;
        tRow.readOnly = SoapService.SoapDataToBool(pSoapData.readOnly);
        tRow.visible = SoapService.SoapDataToBool(pSoapData.visible);
        return (tRow);
    }
}
export class TMRowDef {
    static FromSoapArrayNU(pSoapArray) {
        return (SoapService.SoapDataToArrayNU(pSoapArray, TMRowDef.FromSoapNU));
    }
    static FromSoapNU(pSoapData) {
        if (pSoapData == null)
            throw new Error(ERR_INVALID_ARGUMENT);
        const tRow = new TMRowDef();
        tRow.displayName = pSoapData.displayName;
        tRow.type = pSoapData.type;
        tRow.textId = pSoapData.textId;
        tRow.readOnly = SoapService.SoapDataToBool(pSoapData.readOnly);
        tRow.defaultVisible = SoapService.SoapDataToBool(pSoapData.defaultVisible);
        return (tRow);
    }
}
export class TMTable {
    static FromSoap(pSoapData) {
        if (pSoapData == null)
            return (undefined);
        const tTable = new TMTable();
        tTable.columns = TMColumnDef.FromSoapArrayNU(pSoapData.columns);
        tTable.rows = TMRowDef.FromSoapArrayNU(pSoapData.rows);
        return (tTable);
    }
}
export class TMText {
    static FromSoapArrayNU(pSoapArray) {
        return (SoapService.SoapDataToArrayNU(pSoapArray, TMText.FromSoapNU));
    }
    static FromSoapNU(pSoapData) {
        if (pSoapData == null)
            throw new Error(ERR_INVALID_ARGUMENT);
        const tText = new TMText();
        tText.text = pSoapData.text;
        tText.language = pSoapData.language;
        return (tText);
    }
}
export class UpdateBasketArticleResult {
    static FromSoapArrayNU(pSoapArray) {
        return (SoapService.SoapDataToArrayNU(pSoapArray, UpdateBasketArticleResult.FromSoapNU));
    }
    static FromSoapNU(pSoapData) {
        if (pSoapData == null)
            throw new Error(ERR_INVALID_ARGUMENT);
        const tResult = new UpdateBasketArticleResult();
        tResult.itemId = pSoapData.itemId;
        tResult.updateState = pSoapData.updateState;
        return (tResult);
    }
}
