import type { CalculationLine, CalculationSheet } from "./BasketTypes";
import { Money } from "./BasketTypes";
import type { PricingProcedureInfo, PricingProcedureLineTag } from "./PricingProcedureInfo";
/**
 * Helper class for CalculationSheet handling.
 */
export declare class CalculationSheetInfo {
    get procedure(): PricingProcedureInfo;
    get sheet(): CalculationSheet;
    get purchasePrice(): Money | undefined;
    get unitPurchasePrice(): Money | undefined;
    get salesPrice(): Money | undefined;
    get unitSalesPrice(): Money | undefined;
    get itemNetPrice(): Money | undefined;
    get unitItemNetPrice(): Money | undefined;
    get netPrice(): Money | undefined;
    get unitNetPrice(): Money | undefined;
    get grossPrice(): Money | undefined;
    get unitGrossPrice(): Money | undefined;
    constructor(pProc: PricingProcedureInfo, pSheet: CalculationSheet);
    /**
     * Returns the tags of a CalculationLine as Set which is cached internally.
     */
    getLineTags(pLine: CalculationLine): Set<PricingProcedureLineTag>;
    private mProcedure;
    private mSheet;
    private mPurchasePrice;
    private mUnitPurchasePrice;
    private mSalesPrice;
    private mUnitSalesPrice;
    private mItemNetPrice;
    private mUnitItemNetPrice;
    private mNetPrice;
    private mUnitNetPrice;
    private mGrossPrice;
    private mUnitGrossPrice;
    private prepareInfo;
    private getUnitPrice;
}
