import { BaseEaiwsService } from "../SoapService";
import type { EaiwsSession } from "../EaiwsSession";
import type { GetPackageInfoOptions, LookupOptions, SearchArticleParameterSet, SearchParameterSet, SearchResourceParameterSet } from "./CatalogTypes";
import { CatalogItem, TopCatalogItems, PackageInfo } from "./CatalogTypes";
export declare class CatalogService extends BaseEaiwsService {
    constructor(pOwner: EaiwsSession, pBaseUrl: string, pSessionId: string);
    getCatalogItem(pPath: ReadonlyArray<string>, pOptions?: LookupOptions): Promise<CatalogItem>;
    getCatalogPath(pCatalogId: string, pCatNodeKey: string): Promise<Array<string>>;
    /**
     * Note: The server response will be cached to speed up further calls.
     */
    getLanguages(): Promise<Array<string>>;
    getPackageInfo(pManuIds?: Array<string> | null, pPackageIds?: Array<string> | null, pOptions?: GetPackageInfoOptions): Promise<Array<PackageInfo>>;
    listCatalogItems(pPath: ReadonlyArray<string>, pOptions?: LookupOptions): Promise<Array<CatalogItem>>;
    searchArticle(pSearch: SearchArticleParameterSet, pOptions?: LookupOptions): Promise<TopCatalogItems | undefined>;
    searchCatalogItems(pSearch: SearchParameterSet, pOptions?: LookupOptions): Promise<TopCatalogItems | undefined>;
    searchResource(pSearch: SearchResourceParameterSet, pOptions?: LookupOptions): Promise<TopCatalogItems | undefined>;
    setLanguages(pLanguages: ReadonlyArray<string>): Promise<void>;
    private mLanguages;
}
