/* eslint-disable @typescript-eslint/no-unsafe-return */
/* eslint-disable @typescript-eslint/no-unsafe-member-access */
/* eslint-disable @typescript-eslint/no-unsafe-assignment */
/* eslint-disable @typescript-eslint/no-namespace */
import { __decorate } from "tslib";
import { joinPath } from "./../../utils/string";
import { ERR_INVALID_ARGUMENT } from "../../utils/error";
import { soapAttribute, SoapRequestData, SoapService } from "./../SoapService";
/**
 * @deprecated Use REST API of PriceProfile plugin instead.
 */
export class PriceProfileService extends SoapService {
    constructor(pBaseUrl, pSessionId) {
        super(joinPath(pBaseUrl, "EAIWS/plugins/PriceProfile"), "http://price_profile.plugins.eai.egr/", pSessionId);
    }
    addRules(pAccMeth, pRules) {
        const tPromise = this.soapAjax("addRules", {
            sessionId: this.mSessionId,
            accMeth: pAccMeth,
            rules: pRules
        });
        return (tPromise);
    }
    getRules(pAccMeth) {
        const tPromise = this.soapAjax("getRules", {
            sessionId: this.mSessionId,
            accMeth: pAccMeth
        }).then((pResponse) => {
            return (ConditionRule.FromSoapArrayNU(pResponse));
        });
        return (tPromise);
    }
    loadCsv(pAccMeth, pCsvPath) {
        const tPromise = this.soapAjax("loadCsv", {
            sessionId: this.mSessionId,
            accMeth: pAccMeth,
            csvPath: pCsvPath
        });
        return (tPromise);
    }
    removeRules(pAccMeth) {
        const tPromise = this.soapAjax("removeRules", {
            sessionId: this.mSessionId,
            accMeth: pAccMeth
        });
        return (tPromise);
    }
    //// internal //////////////////////////////////////////////////////////////////////////////
    /** @internal */
    _clearCache() {
    }
}
export class ConditionRule extends SoapRequestData {
    constructor() {
        super();
        this.value = 0;
    }
    static FromSoapArrayNU(pSoapArray) {
        return (SoapService.SoapDataToArrayNU(pSoapArray, ConditionRule.FromSoapNU));
    }
    static FromSoapNU(pSoapData) {
        if (pSoapData == null)
            throw new Error(ERR_INVALID_ARGUMENT);
        const tRule = new ConditionRule();
        tRule.manufacturer = pSoapData.manufacturer;
        tRule.series = pSoapData.series;
        tRule.baseArticleNumber = pSoapData.baseArticleNumber;
        tRule.finalArticleNumber = pSoapData.finalArticleNumber;
        tRule.itemId = pSoapData.itemId;
        tRule.value = SoapService.SoapDataToFloat(pSoapData.value);
        tRule.currency = pSoapData.currency;
        return (tRule);
    }
}
__decorate([
    soapAttribute()
], ConditionRule.prototype, "manufacturer", void 0);
__decorate([
    soapAttribute()
], ConditionRule.prototype, "series", void 0);
__decorate([
    soapAttribute()
], ConditionRule.prototype, "baseArticleNumber", void 0);
__decorate([
    soapAttribute()
], ConditionRule.prototype, "finalArticleNumber", void 0);
__decorate([
    soapAttribute()
], ConditionRule.prototype, "itemId", void 0);
__decorate([
    soapAttribute()
], ConditionRule.prototype, "value", void 0);
__decorate([
    soapAttribute()
], ConditionRule.prototype, "currency", void 0);
//Export ConditionRule as inner class of PriceProfileService
//We have to do this to be backwards compatible with the eaiws bundle of W-CF 8.0
const _ConditionRuleBase = ConditionRule;
(function (PriceProfileService) {
    //is there a better way to export a class alias which also works with `rollup-plugin-dts` ?
    /**
    * @deprecated Use REST API of PriceProfile plugin instead.
    */
    class ConditionRule extends _ConditionRuleBase {
    }
    PriceProfileService.ConditionRule = ConditionRule;
})(PriceProfileService || (PriceProfileService = {}));
