import { BaseEaiwsService } from "../SoapService";
import type { EaiwsSession } from "../EaiwsSession";
import type { AddressType, AuthMessageType, DeleteProjectsOptions, ListCompletionsOptions, ListProjectsOptions, LockingMode, ProjectTextType, SaveProjectOptions, TextFormat } from "./ProjectTypes";
import { AddressData, AutoSaveOptions, ContactData, CountryData, PriceList, ProjectData, ProjectGroup, ProjectNumberScheme, ProjectText, SubdivisionData } from "./ProjectTypes";
export declare class ProjectService extends BaseEaiwsService {
    constructor(pOwner: EaiwsSession, pBaseUrl: string, pSessionId: string);
    addPriceList(pId: string, pStartup: string, pDisplayName: string): Promise<void>;
    addProjectGroup(pId: string, pFolder: boolean, pSimpleName: string, pSubgroupTitle?: string): Promise<void>;
    addProjectNumberScheme(pId: string, pPattern: string, pMinValue?: number, pMaxValue?: number): Promise<void>;
    authenticateUser(pMessageType: AuthMessageType, pMessage?: string): Promise<string | undefined>;
    deleteProjects(pUris: Array<string>, pOptions?: DeleteProjectsOptions): Promise<Array<string>>;
    getAddressData(pAddressTypes?: Array<AddressType>): Promise<Array<AddressData>>;
    getContactData(): Promise<Array<ContactData>>;
    getCountries(): Promise<Array<CountryData>>;
    getCountrySubdivisions(pCountryCode: string): Promise<Array<SubdivisionData>>;
    getPriceLists(pIdPattern: string): Promise<Array<PriceList>>;
    getProjectData(pTextFormat?: TextFormat): Promise<ProjectData | undefined>;
    getProjectGroups(pIdPattern: string): Promise<Array<ProjectGroup>>;
    getProjectNumberSchemes(pIdPattern: string): Promise<Array<ProjectNumberScheme>>;
    getProjectTexts(pTextFormat: TextFormat, pTextTypes?: Array<ProjectTextType>): Promise<Array<ProjectText>>;
    listCompletions(pOptions?: ListCompletionsOptions): Promise<Array<string>>;
    listProjects(pOptions?: ListProjectsOptions): Promise<Array<ProjectData>>;
    loadProject(pUri: string, pLockMode?: LockingMode): Promise<void>;
    newProject(pProjectGroup: string, pPriceList?: string): Promise<void>;
    removeAddressData(pAddressTypes: Array<AddressType>): Promise<Array<AddressType>>;
    removeContactData(pAddressType?: AddressType, pContactIds?: Array<number>): Promise<Array<number>>;
    removePriceList(pId: string): Promise<void>;
    removeProjectGroup(pId: string): Promise<void>;
    removeProjectNumberScheme(pId: string): Promise<void>;
    saveProject(pOptions?: SaveProjectOptions): Promise<string>;
    setAddressData(pAddress: AddressData): Promise<void>;
    setAutoSaveOptions(pOptions?: AutoSaveOptions): Promise<AutoSaveOptions | undefined>;
    setContactData(pContact: ContactData): Promise<void>;
    setProjectData(pData: ProjectData): Promise<void>;
    setProjectText(pText: ProjectText, pUpdate: boolean): Promise<void>;
    updatePriceList(pPriceList: PriceList): Promise<void>;
    updateProjectGroup(pProjectGroup: ProjectGroup): Promise<void>;
    updateProjectLock(pLockMode: LockingMode): Promise<boolean>;
    updateProjectNumberScheme(pNumberScheme: ProjectNumberScheme): Promise<void>;
}
