import { BaseEaiwsService } from "../SoapService";
import type { EaiwsSession } from "../EaiwsSession";
import type { ClientMessage, GetSystemInformationOptions, ImportFileOptions, LoadSessionOptions, LogConfig, ResolveURIsOptions, SaveSessionOptions, SessionCacheFileType, StringPair } from "./SessionTypes";
import { LogData, ProjectSettings, SendMessageResult, SystemInformation } from "./SessionTypes";
export declare class SessionService extends BaseEaiwsService {
    constructor(pOwner: EaiwsSession, pBaseUrl: string, pSessionId: string);
    static GetSystemInformation(pBaseUrl: string, pOptions?: GetSystemInformationOptions): Promise<SystemInformation | undefined>;
    static OpenSession(pBaseUrl: string, pArgs: ReadonlyArray<StringPair>): Promise<string>;
    closeSession(): Promise<void>;
    configureSessionLog(pEnable: boolean, pConfig?: LogConfig): Promise<void>;
    /**
     * Note: The server response will be cached to speed up further calls.
     */
    getLocale(pWithTimeZone?: boolean): Promise<string>;
    getProjectAppData(pAppKey: string, pPaths: ReadonlyArray<string>): Promise<Array<string | null>>;
    getProjectSettings(): Promise<ProjectSettings | undefined>;
    getSessionLog(pReset: boolean): Promise<LogData | undefined>;
    getSessionProperty(pName: string): Promise<string | undefined>;
    getSystemInformation(pOptions?: GetSystemInformationOptions): Promise<SystemInformation | undefined>;
    getUploadURL(pFileType: SessionCacheFileType, pSuffix?: string): Promise<string>;
    importFile(pUrl: string, pAttributes?: ReadonlyArray<string> | null, pOptions?: ImportFileOptions): Promise<string>;
    keepAlive(): Promise<boolean>;
    loadEmptySession(): Promise<void>;
    loadSession(pUri: string, pOptions?: LoadSessionOptions): Promise<string>;
    resolveURIs(pUris: ReadonlyArray<string>, pOptions?: ResolveURIsOptions): Promise<Array<string>>;
    saveSession(pUri: string | null, pOptions?: SaveSessionOptions): Promise<string>;
    sendMessage(pMessages: ReadonlyArray<ClientMessage>): Promise<SendMessageResult>;
    setLocale(pLocale: string, pTimeZone?: string, pTzOffset?: number): Promise<void>;
    setProjectAppData(pAppKey: string, pData: ReadonlyArray<string>): Promise<void>;
    setProjectSettings(pSettings: ProjectSettings): Promise<void>;
    setSessionProperty(pName: string, pValue: string): Promise<void>;
    private mLocale;
}
