import { Plane } from "@babylonjs/core/Maths/math.plane";
import type { Vector2 } from "@babylonjs/core/Maths/math.vector";
import { Vector3 } from "@babylonjs/core/Maths/math.vector";
import type { Application } from "../../core/Application";
import { TransformElements } from "../../core/cmd/TransformElements";
import { BoundingBox } from "../../core/mdl/BoundingBox";
import { AbstractTool } from "../../core/tool/AbstractTool";
import type { InputState } from "../../core/view/InputState";
import type { View } from "../../core/view/View";
export declare abstract class AbstractMove extends AbstractTool {
    constructor(pApp: Application);
    start(pParameter: unknown): boolean;
    stop(): void;
    handlePointerUp(pEvent: PointerEvent, pState: InputState): void;
    handlePointerMove(pEvent: PointerEvent, pState: InputState): void;
    setMoveLimit(pMin: Vector3, pMax: Vector3): void;
    protected mView: View;
    protected mCommand: TransformElements | null;
    protected mIsFinished: boolean;
    protected mMoveY: boolean;
    protected mAllowMoveBelowGround: boolean;
    protected mGroundPosition: number;
    protected mMoveLimitMin: Vector3;
    protected mMoveLimitMax: Vector3;
    protected mPickPlane: Plane;
    protected mRefPoint: Vector3;
    protected mLastPickPos: Vector3 | null;
    protected mPickOffset: Vector3;
    protected mBBoxWorld: BoundingBox;
    protected mTotalTrans: Vector3;
    protected abstract prepareSnapping(): void;
    protected getPickPlane(pRefPoint: Vector3): Plane;
    protected getPointerPosition(pEvent: PointerEvent, pState: InputState, pInitialPos: boolean): Vector2 | null;
    protected getPlanePickPos(pPos: Vector2 | null): Vector3 | null;
    protected performSnap(pPos: Vector3, pEvent: PointerEvent, pState: InputState): Vector3 | null;
    protected preventMoveBelowGround(pPos: Vector3 | null): Vector3 | null;
    protected limitMovement(pPos: Vector3 | null): Vector3 | null;
}
