import { Vector3 } from "@babylonjs/core/Maths/math.vector";
import type { Application } from "../../core/Application";
import { SelectionDefault } from "../../core/tool/SelectionDefault";
import type { InputState } from "../../core/view/InputState";
export declare class Default extends SelectionDefault {
    /** enable/disable move on XZ-plane */
    moveXZEnabled: boolean;
    /** enable/disable move along Y-axis */
    moveYEnabled: boolean;
    /** if disabled it is not possible to move the object below the ground */
    moveYBelowGroundEnabled: boolean;
    /** Y position of the ground */
    groundYPosition: number;
    /** Defines the limit for the object movement in negative direction for each axis. (default: [-20, -20, -20]) */
    moveLimitMin: Vector3;
    /** Defines the limit for the object movement in positive direction for each axis. (default: [20, 20, 20]) */
    moveLimitMax: Vector3;
    /** enable/disable rotation around X-axis */
    rotateXEnabled: boolean;
    /** enable/disable rotation around Y-axis */
    rotateYEnabled: boolean;
    /** enable/disable rotation around Z-axis */
    rotateZEnabled: boolean;
    /** if enabled visibility of move and rotate interactors depend on camera view angle (default: true) */
    automaticInteractorVisibility: boolean;
    constructor(pApp: Application);
    start(pParameter: unknown): boolean;
    stop(): void;
    protected updateInteractors(): void;
    protected startPointerMoveTool(pEvent: PointerEvent, pState: InputState): void;
    private static readonly ROTATE_INTERACTOR_DISTANCE;
    private static readonly ROTATE_INTERACTOR_OFFSET;
    private mRotateInteractorX;
    private mRotateInteractorY;
    private mRotateInteractorZ;
    private mMoveInteractorY;
    private mInteractorManager;
    private mMoveTool;
    private mRotateTool;
    private createInteractors;
    private createInteractor;
    private createRotateInteractor;
    private updateRotateInteractors;
    private updateRotateInteractor;
    private updateMoveInteractorY;
}
