import { Vector3 } from "@babylonjs/core/Maths/math.vector";
import type { Application } from "../../core/Application";
import type { InputState } from "../../core/view/InputState";
import { AbstractMove } from "./AbstractMove";
/**
 * DefaultMove
 */
export declare class DefaultMove extends AbstractMove {
    constructor(pApp: Application);
    start(pParameter: unknown): boolean;
    stop(): void;
    handleKeyUp(pEvent: KeyboardEvent, pState: InputState): void;
    initialize(pRefPoint: Vector3, pStartPointerId: number | null, pMoveY: boolean, pAllowMoveBelowGround: boolean, pGroundPosition: number): void;
    protected prepareSnapping(): void;
    protected performSnap(pPos: Vector3, pEvent: PointerEvent, pState: InputState): Vector3 | null;
    private mStartPointerId;
    private mGridAxis;
    private mSnapGrid;
    private mSnapAxes;
    private mCurrentSnapAxis;
    private mAxisFeedback;
    private mSnapAxisFeedback;
    private mRefPointFeedback;
    private mRefPointFeedbackMat;
    private mBBoxSnapDistance;
    private mBBoxSnapPoints;
    private mBBoxSnapPointsWorld;
    private mBBoxSnapped;
    private mElementSnapData;
    private onCameraChanged;
    private prepareFeedback;
    private clearFeedback;
    private updateFeedback;
    private snapOnAxis;
    private prepareGrid;
    private snapOnGrid;
    private prepareBoundsSnap;
    private updateBBoxSnapDistance;
    private snapOnBounds;
}
