import { Vector3 } from "@babylonjs/core/Maths/math.vector";
import "@babylonjs/core/Meshes/Builders/ribbonBuilder";
import type { Application } from "../../core/Application";
import type { InputState } from "../../core/view/InputState";
import { AbstractRotate } from "./AbstractRotate";
export declare const RotationAxis: {
    readonly X: 0;
    readonly Y: 1;
    readonly Z: 2;
};
export type RotationAxis = typeof RotationAxis[keyof typeof RotationAxis];
export declare class DefaultRotate extends AbstractRotate {
    constructor(pApp: Application);
    start(pParameter: unknown): boolean;
    stop(): void;
    handlePointerMove(pEvent: PointerEvent, pState: InputState): void;
    /**
     * pRefPoint in world coordinates.
     */
    initialize(pRefPoint: Vector3, pStartPoint: Vector3, pAxis: RotationAxis): void;
    private mStartPoint;
    private mLastPickPos;
    private mCircleFeedback;
    private mLineFeedback;
    private mLineFeedbackPosData;
    private mArcFeedback;
    private mArcFeedbackOverlay;
    private mArcFeedbackMat;
    private mArcFeedbackOffset;
    private mValueDiv;
    private mSnapAxes;
    private mCurrentSnapAxis;
    private onCameraChanged;
    private prepareFeedbackAndSnapping;
    private updateFeedbackSize;
    private updateFeedback;
    private snapOnAxis;
}
