import { Vector3 } from "@babylonjs/core/Maths/math.vector";
import type { Application } from "../../core/Application";
import { SelectionDefault } from "../../core/tool/SelectionDefault";
import type { InputState } from "../../core/view/InputState";
export declare class TouchDefault extends SelectionDefault {
    /** if disabled it is not possible to move the object below the ground */
    moveYBelowGroundEnabled: boolean;
    /** Y position of the ground */
    groundYPosition: number;
    /** Defines the limit for the object movement in negative direction for each axis. (default: [-20, -20, -20]) */
    moveLimitMin: Vector3;
    /** Defines the limit for the object movement in positive direction for each axis. (default: [20, 20, 20]) */
    moveLimitMax: Vector3;
    constructor(pApp: Application);
    protected startPointerMoveTool(pEvent: PointerEvent, pState: InputState): void;
    private mMoveTool;
    private mRotateTool;
}
