export type ProgressCallback = (pProgress: number) => void;
export declare class Progress {
    get progress(): number;
    get sectionProgress(): number;
    constructor(pCallback?: ProgressCallback | null, pMultipleSections?: boolean);
    /**
     * Sets the current progress. If multiple sections are used the progress for the
     * current section will be set.
     * @param pProgress The new progress in percent. (range: [0, 100])
     */
    setProgress(pProgress: number): void;
    /**
     * Starts a new progress section and finishes previous one.
     * @param pSize Size of the section in percent.
     */
    startSection(pSize: number): void;
    private mSectionSize;
    private mSectionProgress;
    private mBaseProgress;
    private mProgress;
    private mCallback;
    private finishSection;
}
export default Progress;
