/**
 * Executes pTask sequentially for all elements of pArray.
 * If pTask returns false, the execution is aborted.
 * Returns false if execution was aborted.
 */
export declare function forEach<T>(pArray: Array<T>, pReverseOrder: boolean, pTask: (pIndex: number, pElement: T) => Promise<boolean>): Promise<boolean>;
/**
 * Executes pTask parallel for all elements of pArray.
 * Order of execution is random.
 * Execution is aborted in case of error.
 * The maximum number of concurrent tasks can be defined with the `pMaxConcurrentTasks` parameter.
 * If it is 0 or undefined, the maximum number of concurrent tasks will be unlimited (default: undefined).
 */
export declare function forEachParallel<T, PT>(pArray: Array<T>, pTask: (pIndex: number, pElement: T) => Promise<PT>, pMaxConcurrentTasks?: number): Promise<PT[]>;
/** Returns a promise which resolves after the given timeout. Note: uses `setTimeout` internally. */
export declare function delay(pTimeout?: number): Promise<void>;
/** Returns a promise which resolves with the delay time after `requestAnimationFrame`. */
export declare function delayForAnimation(): Promise<number>;
