export interface LockContext {
    unlock(pAsync?: boolean): void;
}
/** Can be use to synchronize an asynchronous operation to prevent parallel execution. */
export declare class Lock {
    get isLocked(): boolean;
    constructor(pMaxConcurrentTasks?: number);
    acquireLock(): Promise<LockContext>;
    waitWhileLocked(): Promise<void>;
    private mMaxConcurrentTasks;
    private mCurrentRunningTasks;
    private mPromiseQueue;
    private mLockContext;
    private mWaitPromise;
    private mWaitPromiseResolve;
    private onUnlock;
    private resolveNext;
    private resolveWaitPromise;
}
export default Lock;
