import { Lock } from "./Lock";
/**
 * The TaskQueue is a FIFO queue for asynchronous tasks. The tasks are sequentially processed
 * in the order they were added.
 */
export declare class TaskQueue {
    get hasPendingTasks(): boolean;
    constructor(pLock?: Lock);
    addTask<T>(pTask: () => Promise<T>): Promise<T>;
    private mLock;
}
export default TaskQueue;
