/**
 * Wrapper class for window.setTimeout().
 */
export declare class Timer {
    /** true if timer was started */
    get isRunning(): boolean;
    constructor(pHandler: () => void);
    /**
     * Starts the timer. The handler will be executed only once if consecutive calls are
     * made before the timeout.
     * @param pTimeout Timeout in milliseconds for the timer.
     * @param pRestart If true and the timer is currently running, the timer will be restartet
     * with the new timeout. If false the currently running timer will
     * stay active and the new timeout is ignored. (default: false)
     */
    start(pTimeout: number, pRestart?: boolean): void;
    /** stops the timmer if it is currently running */
    stop(): void;
    private mTimer;
    private mHandler;
    private onTimeout;
}
export default Timer;
