import type { Indexable } from "./Indexable";
/**
 * Returns true if the given object is an object.
 */
export declare function isObject(pObj: unknown): pObj is object;
/**
 * Returns true if the given object is plain object.
 */
export declare function isPlainObject(pObj: unknown): pObj is object;
/**
 * Returns true if the object is null or does not contain own properties.
 */
export declare function isNullOrEmpty(pObject: object | null | undefined): pObject is null | undefined;
/**
 * Creates a key/value map for the properties of the given object.
 */
export declare function toMap<T>(pObject: object): Map<string, T>;
/**
 * Creates a plain object using the map entries as propeties.
 */
export declare function fromMap<T>(pMap: Map<string, T>): Indexable<T>;
/**
 * Checks if two objects are shallow equal.
 */
export declare function shallowEqual(pObjectA: object | null | undefined, pObjectB: object | null | undefined): boolean;
